









extern "C" {




typedef SOCKET SOCKET_T;
typedef int SOCKET_T;


typedef union sock_addr {
	struct sockaddr_in in;
	struct sockaddr_un un;
	struct sockaddr_nl nl;
	struct sockaddr_in6 in6;
	struct sockaddr_storage storage;
	struct sockaddr_l2 bt_l2;
	struct sockaddr_rc bt_rc;
	struct sockaddr_sco bt_sco;
	struct sockaddr_ll ll;
} sock_addr_t;



typedef struct {
	PyObject_HEAD
	SOCKET_T sock_fd;	
	int sock_family;	
	int sock_type;		
	int sock_proto;		
	PyObject *(*errorhandler)(void); 
	double sock_timeout;		 
} PySocketSockObject;






typedef struct {
	PyTypeObject *Sock_Type;
        PyObject *error;
} PySocketModule_APIObject;







static
PySocketModule_APIObject PySocketModule;




static
int PySocketModule_ImportModuleAndAPI(void)
{
	PyObject *mod = 0, *v = 0;
	char *apimodule = PySocket_MODULE_NAME;
	char *apiname = PySocket_CAPI_NAME;
	void *api;

	DPRINTF("Importing the %s C API...\n", apimodule);
	mod = PyImport_ImportModule(apimodule);
	if (mod == NULL)
		goto onError;
	DPRINTF(" %s package found\n", apimodule);
	v = PyObject_GetAttrString(mod, apiname);
	if (v == NULL)
		goto onError;
	Py_DECREF(mod);
	DPRINTF(" API object %s found\n", apiname);
	api = PyCObject_AsVoidPtr(v);
	if (api == NULL)
		goto onError;
	Py_DECREF(v);
	memcpy(&PySocketModule, api, sizeof(PySocketModule));
	DPRINTF(" API object loaded and initialized.\n");
	return 0;

 onError:
	DPRINTF(" not found.\n");
	Py_XDECREF(mod);
	Py_XDECREF(v);
	return -1;
}


}
