





typedef struct {
    PyObject_VAR_HEAD
    Py_ssize_t groups; 
    PyObject* groupindex;
    PyObject* indexgroup;
    
    PyObject* pattern; 
    int flags; 
    PyObject *weakreflist; 
    
    Py_ssize_t codesize;
    SRE_CODE code[1];
} PatternObject;


typedef struct {
    PyObject_VAR_HEAD
    PyObject* string; 
    PyObject* regs; 
    PatternObject* pattern; 
    Py_ssize_t pos, endpos; 
    Py_ssize_t lastindex; 
    Py_ssize_t groups; 
    Py_ssize_t mark[1];
} MatchObject;

typedef unsigned int (*SRE_TOLOWER_HOOK)(unsigned int ch);



typedef struct SRE_REPEAT_T {
    Py_ssize_t count;
    SRE_CODE* pattern; 
    void* last_ptr; 
    struct SRE_REPEAT_T *prev; 
} SRE_REPEAT;

typedef struct {
    
    void* ptr; 
    void* beginning; 
    void* start; 
    void* end; 
    
    PyObject* string;
    Py_ssize_t pos, endpos;
    
    int charsize;
    
    Py_ssize_t lastindex;
    Py_ssize_t lastmark;
    void* mark[SRE_MARK_SIZE];
    
    char* data_stack;
    size_t data_stack_size;
    size_t data_stack_base;
    
    SRE_REPEAT *repeat;
    
    SRE_TOLOWER_HOOK lower;
} SRE_STATE;

typedef struct {
    PyObject_HEAD
    PyObject* pattern;
    SRE_STATE state;
} ScannerObject;

