package jp.ac.osaka_u.ist.sel.clonedetector;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;

import jp.ac.osaka_u.ist.sel.clonedetector.data.Method;
import jp.ac.osaka_u.ist.sel.clonedetector.data.Word;

public class VectorCalculator {
		
	/**
	 * <p>\bhXg̃tB^O</p>
	 * @return
	 */
	public ArrayList<Method> filterMethod(){
		ArrayList<Method> newMethodList = new ArrayList<Method>();
		int i=0;
		for(Method method: CloneDetector.methodList){
			if(method.getNodeNum() > Params.NODE_TH &&
					!('A'<=method.getName().charAt(0) && method.getName().charAt(0)<='Z')){
					//!method.getName().contains("test") && !method.getName().contains("Test")&& 
					//!method.getClassName().contains("test") && !method.getClassName().contains("Test")){
				newMethodList.add(method);
				for(Word word: method.getWordList()){					
					if(!CloneDetector.wordMap.containsKey(word.getName()))
						CloneDetector.wordMap.put(word.getName(),i++);					
				}		
			}
		}	
		return newMethodList;
	}
	
	
	/**
	 * <p>ď݂vZ</p>
	 * @throws FileNotFoundException 
	 */
	public void calculateVector() throws FileNotFoundException{
			
		//[h̏opx̌vZ
		int[] wordFreq	= new int[CloneDetector.wordMap.size()];
		for(Method method: CloneDetector.methodList){
			int wordCount = 0;
			int statementCount=0;
			int operatorCount=0;
			for(Word word: method.getWordList()){
				switch(word.getType()){
					case Word.WORD:
						wordCount += word.getCount(); break;	
					case Word.STATEMENT:
						statementCount += word.getCount(); break;
				}
				wordFreq[CloneDetector.wordMap.get(word.getName())]++;
			}
			method.setWordNum(wordCount);			
			method.setStatementNum(statementCount);
			method.setOperatorNum(operatorCount);
		}
		
		//ď݂vZ
		PrintWriter writer=new PrintWriter(new FileOutputStream(CloneDetector.DATASET_FILE));
		for(Method method: CloneDetector.methodList){
			double[] vector = new double[CloneDetector.wordMap.size()];
			for(Word word: method.getWordList()){
				int id = CloneDetector. wordMap.get(word.getName());
				double tf = 0;
				switch(word.getType()){
					case Word.WORD:	 tf = (double)word.getCount() / (double)method.getWordNum(); break;				
					case Word.STATEMENT: tf = (double)word.getCount() / (double)method.getStatementNum(); break;		
				}						
				double idf = 1+Math.log((double)CloneDetector.methodList.size()/(double)wordFreq[id]);
				vector[id] = tf*idf;				
			}
			method.setVector(vector);
			double len = 0;
			for(double i:vector){
				writer.printf("%f ",i);
				len += i*i;
			}
			method.setLen(Math.sqrt(len));
			writer.println();
			
		}		
		writer.close();
	}

}
