package jp.ac.osaka_u.ist.sel.y_yuuki.cn;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Calendar;

/**
 * sȌo̓NX.
 * @author y-yuuki
 */
public class Logger {

	/** Ot@Cɏo͂s{@link PrintWriter}NX. */
	private static PrintWriter logger;

	/** ݎ{@link Calendar}NX. */
	private static Calendar now = Calendar.getInstance();

	/** ݎ(). */
	private static String hour;

	/** ݎ(). */
	private static String minute;

	/** ݎ(b). */
	private static String second;

	/**
	 * 񃌃x. fobOp.
	 * @author m-sano
	 */
	public static final int DEBUG = -1;

	/**
	 * 񃌃x. Ƃ͖֌Wȏ.
	 * @author m-sano
	 */
	public static final int INFO = 0;

	/**
	 * xx. s͌pł邪, sʂɈُ킪o\ꍇ.
	 * @author m-sano
	 */
	public static final int WARNING = 1;

	/**
	 * G[x. sss\ȏꍇ.
	 * @author m-sano
	 */
	public static final int ERROR = 2;

	/**
	 * vIx. s\Ԃ̗LɊւ炸, vOɌׂꍇ.
	 * @author m-sano
	 */
	public static final int FATAL = 3;

	/**
	 * VXex. K\VXebZ[W.
	 * @author m-sano
	 */
	public static final int SYSTEM = 4;

	/**
	 * o͂sOx.
	 * @author m-sano
	 */
	private static int level = Logger.WARNING;



	/**
	 * K[, Ot@Cւ݂̏Jn.
	 * @throws IOException Ot@Co͂Ɏsꍇ
	 */
	public static void init() throws IOException {
		logger = new PrintWriter(new BufferedWriter(new FileWriter(new File(Def.LOG_FILE),true)));
		String year = Integer.toString(now.get(Calendar.YEAR));
		String month = Integer.toString(now.get(Calendar.MONTH) + 1);

		// 2ɂ
		if(month.length() == 1) {
			month = "0" + month;
		}

		// 2ɂ
		String day = Integer.toString(now.get(Calendar.DATE));
		if(day.length() == 1) {
			day = "0" + day;
		}
		Logger.writeln("######  " + year +" / " + month +" / " + day + "  #####");
	}



	/**
	 * Ot@Cɏ݂s. ݎԂIɕt.
	 * @param msg bZ[W.
	 * @author y-yuuki
	 * @author m-sano Oxɔ, ANZXCq<code>private</code>ɕύX.
	 */
	private static void writeln(String msg) {
		updateTime();
		logger.println(msg + " ( " + hour + ":" + minute + ":" + second + " )");
		logger.flush();
	}



	/**
	 * Ot@Cɏ݂s. ݎԂIɕt.
	 * @param msg bZ[W.
	 * @param level Ox.
	 * @author m-sano Oxɔ, ANZXCq<code>private</code>ɕύX.
	 */
	public static void writeln(String msg, int level) {
		if(level >= Logger.level) {
			String prefix = getLevelPrefix(level);
			Logger.writeln(prefix + msg);
		}
	}



	/**
	 * Ot@Cւ݂̏{, VXeI.
	 * @param msg IbZ[W.
	 * @param level Ox.
	 * @author y-yuuki
	 * @author m-sano Ox̎wǉ.
	 */
	public static void finish(String msg, int level) {
		Logger.writeln(msg, level);
		logger.close();
		System.exit(0);		// TODO ُȈꍇƕԂlʂKv
	}



	/**
	 * ݎXV.
	 */
	private static void updateTime() {
		now = Calendar.getInstance();
		hour = Integer.toString(now.get(Calendar.HOUR_OF_DAY));

		// Ԃ2ɂ
		if(hour.length() == 1) {
			hour = "0" + hour;
		}

		minute = Integer.toString(now.get(Calendar.MINUTE));

		// 2ɂ
		if(minute.length() == 1) {
			minute = "0" + minute;
		}

		second = Integer.toString(now.get(Calendar.SECOND));

		// b2ɂ
		if(second.length() == 1) {
			second = "0" + second;
		}
	}



	/**
	 * <p>R\[ (<code>System.err</code>) ɃbZ[Wo͂.
	 * w背xɉړt^.</p>
	 * @param mes bZ[W.
	 * @param loglevel Ox.
	 * @author m-sano
	 */
	public static void printlnConsole(String mes, int loglevel) {
		if(loglevel >= Logger.level) {
			String prefix = getLevelPrefix(loglevel);
			System.err.println(prefix + mes);
		}
	}



	/**
	 * Oxɉړ擾.
	 * @param level Ox.
	 * @return OxӖړ. sȃx̏ꍇ͋󕶎.
	 * @author m-sano
	 */
	private static String getLevelPrefix(int level) {
		String prefix = "";
		switch(level) {
		case INFO:
			prefix = "INFO: ";
			break;

		case WARNING:
			prefix = "WARNING: ";
			break;

		case ERROR:
			prefix = "ERROR: ";
			break;

		case FATAL:
			prefix = "FATAL: ";
			break;

		case SYSTEM:
		case DEBUG:
			prefix = "";
			break;

		default:
			printlnConsole("Specified unknown log level. [getLevelPrefix]", FATAL);
			break;
		}
		return prefix;
	}
}

