package jp.ac.osaka_u.ist.sel.y_yuuki.cn;

import java.io.File;
import java.io.IOException;

import jp.ac.osaka_u.ist.sel.y_yuuki.cn.analyze.AnalyzeManager;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Project;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.generate.OutputGenerator;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.mail.MailSender;

/**
 * CloneNotifierCNX.
 * @author y-yuuki
 */
public class Main {

	/**
	 * C\bh.
	 * @param args <code><i>SettingFileName</i> [ <i>SettingFileName</i>... ]</code>
	 */
	public static void main(String[] args) {

		// Ot@C
		try {
			Logger.init();
		} catch (IOException e) {
			Logger.printlnConsole("Can't generate log file.", Logger.ERROR);
			System.exit(1);
		}

		// ԃt@CfBNg
		if(!(new File(Def.WORK_DIR)).exists()) {
			Logger.writeln("Create directory 'file'.", Logger.INFO);
			(new File(Def.WORK_DIR)).mkdirs();
		}

		// ɂ͕̐ݒt@Cwł
		int argnum = 1;
		for(String arg: args) {
			Logger.writeln("--- Analyze Project" + Integer.toString(argnum) + "---", Logger.SYSTEM);
			Logger.printlnConsole("--- Analyze Project" + Integer.toString(argnum++) + "---", Logger.SYSTEM);

			Project project = new Project();

			// ݒt@CǍ
			if(SettingFileLoader.loadSettingFile(arg, project)) {
				Logger.writeln("<Success> Load setting file.", Logger.SYSTEM);

				boolean okFlg = true;	// vWFNg̃`FbNAEgɎs false ɂȂ

				// `FbNAEg̎s
				if(project.isCheckout()) {
					if(!(okFlg = VCSController.checkoutProject(project))) {
						Logger.writeln("Can't checkout project.", Logger.ERROR);
						okFlg = false;
					} else {
						Logger.writeln("<Success> Checkout new version of " + project.getName() + ".", Logger.SYSTEM);
					}
				}

				// `FbNAEgɐ
				if(okFlg) {

					// R[hN[̎擾
					if(AnalyzeManager.getCloneInf(project)) {
						Logger.writeln("<Success> Extract code clone information.", Logger.SYSTEM);

						//R[hN[̕
						if(AnalyzeManager.categorizeClone(project)){

							Logger.writeln("<Success> Categorize code clones.", Logger.SYSTEM);

							// ތʂ̏o
							OutputGenerator generator = new OutputGenerator(project);

							// eLXg
							if(project.isGenerateText()) {
								generator.generateTextFile();
								MailSender.sendMail(project);
							}

							// CSV
							if(project.isGenerateCSV()) {
								generator.generateCSVFile();
							}

							// HTML
							if(project.isGenerateHtml()) {
								generator.generateHTMLFile();
							}
						}
					} else {
						Logger.writeln("Can't extract code clone information.", Logger.ERROR);
					}
				}
			} else {
				Logger.writeln("Can't load setting file.", Logger.ERROR);
			}
		}

		Logger.finish("End.", Logger.SYSTEM);
	}
}
