package jp.ac.osaka_u.ist.sel.y_yuuki.cn;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.file.DirectoryNotEmptyException;
import java.nio.file.Files;

import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Project;

/**
 * <p>VCSǗNX</p>
 * @author y-yuuki
 */
public class VCSController {

	/**
	 * <p>vWFNg̃`FbNAEg<p>
	 * @param project ProjectIuWFNg
	 * @return <ul>
	 *           <li>̏ꍇ - true</li>
	 *           <li>s̏ꍇ - false</li>
	 *         </ul>
	 */
	public static boolean checkoutProject(Project project) {

		if(!deleteDir(project.getOldDir())) {
			Logger.writeln("Can't delete old directory.", Logger.ERROR);
		}

		if(!changeDir(project.getNewDir(), project.getOldDir())) {
			Logger.writeln("Can't move old directory.", Logger.ERROR);
		}

		// TODO CloneDetector ̏ꍇ, X ".ccfxprepdir" ݂Ȃɂւ炸G[OoĂ
		if(!deleteDir(project.getOldDir() + "\\.ccfxprepdir")){
			Logger.writeln("Can't delete '.ccfxprepdir' directory.", Logger.ERROR);
		}

		String[] cmdarray = project.getCheckoutCmd().split(" ");
		ProcessBuilder pb = new ProcessBuilder(cmdarray);
		Process p;
		try {
			p = pb.start();
			BufferedReader reader = new BufferedReader(new InputStreamReader(p.getInputStream()));

			Logger.writeln("Start checkout command.", Logger.SYSTEM);

			String line;
			while((line = reader.readLine())!=null) {
				Logger.writeln("\t" + line, Logger.SYSTEM);
			}

			reader.close();
		}catch (IOException e1){
			return false;
		}

		if(!((new File(project.getNewDir())).exists())){
			(new File(project.getNewDir())).mkdirs();
			return false;
		}

		if(!((new File(project.getOldDir())).exists())){
			(new File(project.getOldDir())).mkdirs();
			return false;
		}
		return true;
	}

	/**
	 * fBNg̕ύX
	 * @author y-yuuki
	 * @author m-sano
	 */
	private static boolean changeDir(String dirA, String dirB) {
		File fileA = new File(dirA);
		File fileB = new File(dirB);

		if(fileA.exists()) {
			return fileA.renameTo(fileB);
		}
		return true;
	}

	/**
	 * fBNg̍폜
	 */
	public static boolean deleteDir(String dir) {
		File file = new File(dir);
		if(file.exists()) {
			if(file.isDirectory()) {
				File[] f = file.listFiles();
				for(int i = 0; i < f.length; i++) {
					deleteDir(f[i].toString());
				}
			}
		}

		boolean result = false;
		try {
			file.setWritable(true);
			result = Files.deleteIfExists(file.toPath());
		} catch (DirectoryNotEmptyException e) {
			Logger.writeln("<DirectoryNotEmptyException> Can't delete " + file.toString(), Logger.FATAL);
			result = false;
		} catch (IOException e) {
			Logger.writeln("<IOException> Can't delete " + file.toString(), Logger.FATAL);
			Logger.writeln("\tWritable: " + file.canWrite(), Logger.DEBUG);
			Logger.writeln("\tReadable: " + file.canRead(), Logger.DEBUG);
		}

		return result;
	}
}
