package jp.ac.osaka_u.ist.sel.m_sano.extractor;

import static org.junit.Assert.*;

import java.util.ArrayList;

import jp.ac.osaka_u.ist.sel.y_yuuki.cn.Logger;
import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Method;

import org.junit.Test;

public class JavaMethodExtractorTest {

	/**
	 * AntClassLoader
	 * @throws Exception
	 */
	@Test
	public void testExtractMethod01() throws Exception {
		Logger.init();

		JavaMethodExtractor jme = new JavaMethodExtractor("testfile/Application/ant/src/AntClassLoader.java");
		ArrayList<Method> mdList = jme.extractMethod();

		assertEquals(66, mdList.size());

		assertEquals("ResourceEnumeration", mdList.get(0).getName());
		assertEquals("AntClassLoader.ResourceEnumeration.ResourceEnumeration", mdList.get(0).getModifiedName());
		assertEquals("(String name)", mdList.get(0).getParams());
		assertEquals("(String)", mdList.get(0).getParamTypeOnly(true));
		assertEquals(108, mdList.get(0).getStartLine());
		assertEquals(9, mdList.get(0).getStartColumn());
		assertEquals(112, mdList.get(0).getEndLine());
		assertEquals(9, mdList.get(0).getEndColumn());

		assertEquals("hasMoreElements", mdList.get(1).getName());
		assertEquals("AntClassLoader.ResourceEnumeration.hasMoreElements", mdList.get(1).getModifiedName());
		assertEquals("()", mdList.get(1).getParams());
		assertEquals("()", mdList.get(1).getParamTypeOnly(true));
		assertEquals(121, mdList.get(1).getStartLine());
		assertEquals(9, mdList.get(1).getStartColumn());
		assertEquals(123, mdList.get(1).getEndLine());
		assertEquals(9, mdList.get(1).getEndColumn());

		assertEquals("nextElement", mdList.get(2).getName());
		assertEquals("AntClassLoader.ResourceEnumeration.nextElement", mdList.get(2).getModifiedName());
		assertEquals("()", mdList.get(2).getParams());
		assertEquals("()", mdList.get(2).getParamTypeOnly(true));
		assertEquals(130, mdList.get(2).getStartLine());
		assertEquals(9, mdList.get(2).getStartColumn());
		assertEquals(137, mdList.get(2).getEndLine());
		assertEquals(9, mdList.get(2).getEndColumn());

		assertEquals("findNextResource", mdList.get(3).getName());
		assertEquals("AntClassLoader.ResourceEnumeration.findNextResource", mdList.get(3).getModifiedName());
		assertEquals("()", mdList.get(3).getParams());
		assertEquals("()", mdList.get(3).getParamTypeOnly(true));
		assertEquals(145, mdList.get(3).getStartLine());
		assertEquals(9, mdList.get(3).getStartColumn());
		assertEquals(158, mdList.get(3).getEndLine());
		assertEquals(9, mdList.get(3).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(4).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(4).getModifiedName());
		assertEquals("(ClassLoader parent,Project project,Path classpath)", mdList.get(4).getParams());
		assertEquals("(ClassLoader,Project,Path)", mdList.get(4).getParamTypeOnly(true));
		assertEquals(243, mdList.get(4).getStartLine());
		assertEquals(5, mdList.get(4).getStartColumn());
		assertEquals(247, mdList.get(4).getEndLine());
		assertEquals(5, mdList.get(4).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(5).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(5).getModifiedName());
		assertEquals("()", mdList.get(5).getParams());
		assertEquals("()", mdList.get(5).getParamTypeOnly(true));
		assertEquals(252, mdList.get(5).getStartLine());
		assertEquals(5, mdList.get(5).getStartColumn());
		assertEquals(254, mdList.get(5).getEndLine());
		assertEquals(5, mdList.get(5).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(6).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(6).getModifiedName());
		assertEquals("(Project project,Path classpath)", mdList.get(6).getParams());
		assertEquals("(Project,Path)", mdList.get(6).getParamTypeOnly(true));
		assertEquals(267, mdList.get(6).getStartLine());
		assertEquals(5, mdList.get(6).getStartColumn());
		assertEquals(271, mdList.get(6).getEndLine());
		assertEquals(5, mdList.get(6).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(7).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(7).getModifiedName());
		assertEquals("(ClassLoader parent,Project project,Path classpath,boolean parentFirst)", mdList.get(7).getParams());
		assertEquals("(ClassLoader,Project,Path,boolean)", mdList.get(7).getParamTypeOnly(true));
		assertEquals(289, mdList.get(7).getStartLine());
		assertEquals(5, mdList.get(7).getStartColumn());
		assertEquals(297, mdList.get(7).getEndLine());
		assertEquals(5, mdList.get(7).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(8).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(8).getModifiedName());
		assertEquals("(Project project,Path classpath,boolean parentFirst)", mdList.get(8).getParams());
		assertEquals("(Project,Path,boolean)", mdList.get(8).getParamTypeOnly(true));
		assertEquals(311, mdList.get(8).getStartLine());
		assertEquals(5, mdList.get(8).getStartColumn());
		assertEquals(313, mdList.get(8).getEndLine());
		assertEquals(5, mdList.get(8).getEndColumn());

		assertEquals("AntClassLoader", mdList.get(9).getName());
		assertEquals("AntClassLoader.AntClassLoader", mdList.get(9).getModifiedName());
		assertEquals("(ClassLoader parent,boolean parentFirst)", mdList.get(9).getParams());
		assertEquals("(ClassLoader,boolean)", mdList.get(9).getParamTypeOnly(true));
		assertEquals(328, mdList.get(9).getStartLine());
		assertEquals(5, mdList.get(9).getStartColumn());
		assertEquals(332, mdList.get(9).getEndLine());
		assertEquals(5, mdList.get(9).getEndColumn());

		assertEquals("setProject", mdList.get(10).getName());
		assertEquals("AntClassLoader.setProject", mdList.get(10).getModifiedName());
		assertEquals("(Project project)", mdList.get(10).getParams());
		assertEquals("(Project)", mdList.get(10).getParamTypeOnly(true));
		assertEquals(339, mdList.get(10).getStartLine());
		assertEquals(5, mdList.get(10).getStartColumn());
		assertEquals(344, mdList.get(10).getEndLine());
		assertEquals(5, mdList.get(10).getEndColumn());

		assertEquals("setClassPath", mdList.get(11).getName());
		assertEquals("AntClassLoader.setClassPath", mdList.get(11).getModifiedName());
		assertEquals("(Path classpath)", mdList.get(11).getParams());
		assertEquals("(Path)", mdList.get(11).getParamTypeOnly(true));
		assertEquals(353, mdList.get(11).getStartLine());
		assertEquals(5, mdList.get(11).getStartColumn());
		assertEquals(367, mdList.get(11).getEndLine());
		assertEquals(5, mdList.get(11).getEndColumn());

		assertEquals("setParent", mdList.get(12).getName());
		assertEquals("AntClassLoader.setParent", mdList.get(12).getModifiedName());
		assertEquals("(ClassLoader parent)", mdList.get(12).getParams());
		assertEquals("(ClassLoader)", mdList.get(12).getParamTypeOnly(true));
		assertEquals(375, mdList.get(12).getStartLine());
		assertEquals(5, mdList.get(12).getStartColumn());
		assertEquals(377, mdList.get(12).getEndLine());
		assertEquals(5, mdList.get(12).getEndColumn());

		assertEquals("setParentFirst", mdList.get(13).getName());
		assertEquals("AntClassLoader.setParentFirst", mdList.get(13).getModifiedName());
		assertEquals("(boolean parentFirst)", mdList.get(13).getParams());
		assertEquals("(boolean)", mdList.get(13).getParamTypeOnly(true));
		assertEquals(387, mdList.get(13).getStartLine());
		assertEquals(5, mdList.get(13).getStartColumn());
		assertEquals(389, mdList.get(13).getEndLine());
		assertEquals(5, mdList.get(13).getEndColumn());

		assertEquals("log", mdList.get(14).getName());
		assertEquals("AntClassLoader.log", mdList.get(14).getModifiedName());
		assertEquals("(String message,int priority)", mdList.get(14).getParams());
		assertEquals("(String,int)", mdList.get(14).getParamTypeOnly(true));
		assertEquals(399, mdList.get(14).getStartLine());
		assertEquals(5, mdList.get(14).getStartColumn());
		assertEquals(403, mdList.get(14).getEndLine());
		assertEquals(5, mdList.get(14).getEndColumn());

		assertEquals("setThreadContextLoader", mdList.get(15).getName());
		assertEquals("AntClassLoader.setThreadContextLoader", mdList.get(15).getModifiedName());
		assertEquals("()", mdList.get(15).getParams());
		assertEquals("()", mdList.get(15).getParamTypeOnly(true));
		assertEquals(409, mdList.get(15).getStartLine());
		assertEquals(5, mdList.get(15).getStartColumn());
		assertEquals(422, mdList.get(15).getEndLine());
		assertEquals(5, mdList.get(15).getEndColumn());

		assertEquals("resetThreadContextLoader", mdList.get(16).getName());
		assertEquals("AntClassLoader.resetThreadContextLoader", mdList.get(16).getModifiedName());
		assertEquals("()", mdList.get(16).getParams());
		assertEquals("()", mdList.get(16).getParamTypeOnly(true));
		assertEquals(427, mdList.get(16).getStartLine());
		assertEquals(5, mdList.get(16).getStartColumn());
		assertEquals(433, mdList.get(16).getEndLine());
		assertEquals(5, mdList.get(16).getEndColumn());

		assertEquals("addPathElement", mdList.get(17).getName());
		assertEquals("AntClassLoader.addPathElement", mdList.get(17).getModifiedName());
		assertEquals("(String pathElement)", mdList.get(17).getParams());
		assertEquals("(String)", mdList.get(17).getParamTypeOnly(true));
		assertEquals(445, mdList.get(17).getStartLine());
		assertEquals(5, mdList.get(17).getStartColumn());
		assertEquals(453, mdList.get(17).getEndLine());
		assertEquals(5, mdList.get(17).getEndColumn());

		assertEquals("addPathComponent", mdList.get(18).getName());
		assertEquals("AntClassLoader.addPathComponent", mdList.get(18).getModifiedName());
		assertEquals("(File file)", mdList.get(18).getParams());
		assertEquals("(File)", mdList.get(18).getParamTypeOnly(true));
		assertEquals(462, mdList.get(18).getStartLine());
		assertEquals(5, mdList.get(18).getStartColumn());
		assertEquals(467, mdList.get(18).getEndLine());
		assertEquals(5, mdList.get(18).getEndColumn());

		assertEquals("addPathFile", mdList.get(19).getName());
		assertEquals("AntClassLoader.addPathFile", mdList.get(19).getModifiedName());
		assertEquals("(File pathComponent)", mdList.get(19).getParams());
		assertEquals("(File)", mdList.get(19).getParamTypeOnly(true));
		assertEquals(479, mdList.get(19).getStartLine());
		assertEquals(5, mdList.get(19).getStartColumn());
		assertEquals(530, mdList.get(19).getEndLine());
		assertEquals(5, mdList.get(19).getEndColumn());

		assertEquals("getClasspath", mdList.get(20).getName());
		assertEquals("AntClassLoader.getClasspath", mdList.get(20).getModifiedName());
		assertEquals("()", mdList.get(20).getParams());
		assertEquals("()", mdList.get(20).getParamTypeOnly(true));
		assertEquals(538, mdList.get(20).getStartLine());
		assertEquals(5, mdList.get(20).getStartColumn());
		assertEquals(551, mdList.get(20).getEndLine());
		assertEquals(5, mdList.get(20).getEndColumn());

		assertEquals("setIsolated", mdList.get(21).getName());
		assertEquals("AntClassLoader.setIsolated", mdList.get(21).getModifiedName());
		assertEquals("(boolean isolated)", mdList.get(21).getParams());
		assertEquals("(boolean)", mdList.get(21).getParamTypeOnly(true));
		assertEquals(562, mdList.get(21).getStartLine());
		assertEquals(5, mdList.get(21).getStartColumn());
		assertEquals(564, mdList.get(21).getEndLine());
		assertEquals(5, mdList.get(21).getEndColumn());

		assertEquals("initializeClass", mdList.get(22).getName());
		assertEquals("AntClassLoader.initializeClass", mdList.get(22).getModifiedName());
		assertEquals("(Class<?> theClass)", mdList.get(22).getParams());
		assertEquals("(Class)", mdList.get(22).getParamTypeOnly(true));
		assertEquals(576, mdList.get(22).getStartLine());
		assertEquals(5, mdList.get(22).getStartColumn());
		assertEquals(607, mdList.get(22).getEndLine());
		assertEquals(5, mdList.get(22).getEndColumn());

		assertEquals("addSystemPackageRoot", mdList.get(23).getName());
		assertEquals("AntClassLoader.addSystemPackageRoot", mdList.get(23).getModifiedName());
		assertEquals("(String packageRoot)", mdList.get(23).getParams());
		assertEquals("(String)", mdList.get(23).getParamTypeOnly(true));
		assertEquals(618, mdList.get(23).getStartLine());
		assertEquals(5, mdList.get(23).getStartColumn());
		assertEquals(620, mdList.get(23).getEndLine());
		assertEquals(5, mdList.get(23).getEndColumn());

		assertEquals("addLoaderPackageRoot", mdList.get(24).getName());
		assertEquals("AntClassLoader.addLoaderPackageRoot", mdList.get(24).getModifiedName());
		assertEquals("(String packageRoot)", mdList.get(24).getParams());
		assertEquals("(String)", mdList.get(24).getParamTypeOnly(true));
		assertEquals(631, mdList.get(24).getStartLine());
		assertEquals(5, mdList.get(24).getStartColumn());
		assertEquals(633, mdList.get(24).getEndLine());
		assertEquals(5, mdList.get(24).getEndColumn());

		assertEquals("forceLoadClass", mdList.get(25).getName());
		assertEquals("AntClassLoader.forceLoadClass", mdList.get(25).getModifiedName());
		assertEquals("(String classname)", mdList.get(25).getParams());
		assertEquals("(String)", mdList.get(25).getParamTypeOnly(true));
		assertEquals(650, mdList.get(25).getStartLine());
		assertEquals(5, mdList.get(25).getStartColumn());
		assertEquals(659, mdList.get(25).getEndLine());
		assertEquals(5, mdList.get(25).getEndColumn());

		assertEquals("forceLoadSystemClass", mdList.get(26).getName());
		assertEquals("AntClassLoader.forceLoadSystemClass", mdList.get(26).getModifiedName());
		assertEquals("(String classname)", mdList.get(26).getParams());
		assertEquals("(String)", mdList.get(26).getParamTypeOnly(true));
		assertEquals(677, mdList.get(26).getStartLine());
		assertEquals(5, mdList.get(26).getStartColumn());
		assertEquals(686, mdList.get(26).getEndLine());
		assertEquals(5, mdList.get(26).getEndColumn());

		assertEquals("getResourceAsStream", mdList.get(27).getName());
		assertEquals("AntClassLoader.getResourceAsStream", mdList.get(27).getModifiedName());
		assertEquals("(String name)", mdList.get(27).getParams());
		assertEquals("(String)", mdList.get(27).getParamTypeOnly(true));
		assertEquals(697, mdList.get(27).getStartLine());
		assertEquals(5, mdList.get(27).getStartColumn());
		assertEquals(727, mdList.get(27).getEndLine());
		assertEquals(5, mdList.get(27).getEndColumn());

		assertEquals("loadResource", mdList.get(28).getName());
		assertEquals("AntClassLoader.loadResource", mdList.get(28).getModifiedName());
		assertEquals("(String name)", mdList.get(28).getParams());
		assertEquals("(String)", mdList.get(28).getParamTypeOnly(true));
		assertEquals(738, mdList.get(28).getStartLine());
		assertEquals(5, mdList.get(28).getStartColumn());
		assertEquals(749, mdList.get(28).getEndLine());
		assertEquals(5, mdList.get(28).getEndColumn());

		assertEquals("loadBaseResource", mdList.get(29).getName());
		assertEquals("AntClassLoader.loadBaseResource", mdList.get(29).getModifiedName());
		assertEquals("(String name)", mdList.get(29).getParams());
		assertEquals("(String)", mdList.get(29).getParamTypeOnly(true));
		assertEquals(761, mdList.get(29).getStartLine());
		assertEquals(5, mdList.get(29).getStartColumn());
		assertEquals(763, mdList.get(29).getEndLine());
		assertEquals(5, mdList.get(29).getEndColumn());

		assertEquals("getResourceStream", mdList.get(30).getName());
		assertEquals("AntClassLoader.getResourceStream", mdList.get(30).getModifiedName());
		assertEquals("(File file,String resourceName)", mdList.get(30).getParams());
		assertEquals("(File,String)", mdList.get(30).getParamTypeOnly(true));
		assertEquals(777, mdList.get(30).getStartLine());
		assertEquals(5, mdList.get(30).getStartColumn());
		assertEquals(807, mdList.get(30).getEndLine());
		assertEquals(5, mdList.get(30).getEndColumn());

		assertEquals("isParentFirst", mdList.get(31).getName());
		assertEquals("AntClassLoader.isParentFirst", mdList.get(31).getModifiedName());
		assertEquals("(String resourceName)", mdList.get(31).getParams());
		assertEquals("(String)", mdList.get(31).getParamTypeOnly(true));
		assertEquals(822, mdList.get(31).getStartLine());
		assertEquals(5, mdList.get(31).getStartColumn());
		assertEquals(847, mdList.get(31).getEndLine());
		assertEquals(5, mdList.get(31).getEndColumn());

		assertEquals("getRootLoader", mdList.get(32).getName());
		assertEquals("AntClassLoader.getRootLoader", mdList.get(32).getModifiedName());
		assertEquals("()", mdList.get(32).getParams());
		assertEquals("()", mdList.get(32).getParamTypeOnly(true));
		assertEquals(853, mdList.get(32).getStartLine());
		assertEquals(5, mdList.get(32).getStartColumn());
		assertEquals(859, mdList.get(32).getEndLine());
		assertEquals(5, mdList.get(32).getEndColumn());

		assertEquals("getResource", mdList.get(33).getName());
		assertEquals("AntClassLoader.getResource", mdList.get(33).getModifiedName());
		assertEquals("(String name)", mdList.get(33).getParams());
		assertEquals("(String)", mdList.get(33).getParamTypeOnly(true));
		assertEquals(873, mdList.get(33).getStartLine());
		assertEquals(5, mdList.get(33).getStartColumn());
		assertEquals(909, mdList.get(33).getEndLine());
		assertEquals(5, mdList.get(33).getEndColumn());

		assertEquals("getNamedResources", mdList.get(34).getName());
		assertEquals("AntClassLoader.getNamedResources", mdList.get(34).getModifiedName());
		assertEquals("(String name)", mdList.get(34).getParams());
		assertEquals("(String)", mdList.get(34).getParamTypeOnly(true));
		assertEquals(921, mdList.get(34).getStartLine());
		assertEquals(5, mdList.get(34).getStartColumn());
		assertEquals(924, mdList.get(34).getEndLine());
		assertEquals(5, mdList.get(34).getEndColumn());

		assertEquals("findResources", mdList.get(35).getName());
		assertEquals("AntClassLoader.findResources", mdList.get(35).getModifiedName());
		assertEquals("(String name)", mdList.get(35).getParams());
		assertEquals("(String)", mdList.get(35).getParamTypeOnly(true));
		assertEquals(935, mdList.get(35).getStartLine());
		assertEquals(5, mdList.get(35).getStartColumn());
		assertEquals(937, mdList.get(35).getEndLine());
		assertEquals(5, mdList.get(35).getEndColumn());

		assertEquals("findResources", mdList.get(36).getName());
		assertEquals("AntClassLoader.findResources", mdList.get(36).getModifiedName());
		assertEquals("(String name,boolean parentHasBeenSearched)", mdList.get(36).getParams());
		assertEquals("(String,boolean)", mdList.get(36).getParamTypeOnly(true));
		assertEquals(951, mdList.get(36).getStartLine());
		assertEquals(5, mdList.get(36).getStartColumn());
		assertEquals(977, mdList.get(36).getEndLine());
		assertEquals(5, mdList.get(36).getEndColumn());

		assertEquals("getResourceURL", mdList.get(37).getName());
		assertEquals("AntClassLoader.getResourceURL", mdList.get(37).getModifiedName());
		assertEquals("(File file,String resourceName)", mdList.get(37).getParams());
		assertEquals("(File,String)", mdList.get(37).getParamTypeOnly(true));
		assertEquals(991, mdList.get(37).getStartLine());
		assertEquals(5, mdList.get(37).getStartColumn());
		assertEquals(1038, mdList.get(37).getEndLine());
		assertEquals(5, mdList.get(37).getEndColumn());

		assertEquals("loadClass", mdList.get(38).getName());
		assertEquals("AntClassLoader.loadClass", mdList.get(38).getModifiedName());
		assertEquals("(String classname,boolean resolve)", mdList.get(38).getParams());
		assertEquals("(String,boolean)", mdList.get(38).getParamTypeOnly(true));
		assertEquals(1060, mdList.get(38).getStartLine());
		assertEquals(5, mdList.get(38).getStartColumn());
		assertEquals(1096, mdList.get(38).getEndLine());
		assertEquals(5, mdList.get(38).getEndColumn());

		assertEquals("getClassFilename", mdList.get(39).getName());
		assertEquals("AntClassLoader.getClassFilename", mdList.get(39).getModifiedName());
		assertEquals("(String classname)", mdList.get(39).getParams());
		assertEquals("(String)", mdList.get(39).getParamTypeOnly(true));
		assertEquals(1107, mdList.get(39).getStartLine());
		assertEquals(5, mdList.get(39).getStartColumn());
		assertEquals(1109, mdList.get(39).getEndLine());
		assertEquals(5, mdList.get(39).getEndColumn());

		assertEquals("defineClassFromData", mdList.get(40).getName());
		assertEquals("AntClassLoader.defineClassFromData", mdList.get(40).getModifiedName());
		assertEquals("(File container,byte[] classData,String classname)", mdList.get(40).getParams());
		assertEquals("(File,byte[],String)", mdList.get(40).getParamTypeOnly(true));
		assertEquals(1124, mdList.get(40).getStartLine());
		assertEquals(5, mdList.get(40).getStartColumn());
		assertEquals(1138, mdList.get(40).getEndLine());
		assertEquals(5, mdList.get(40).getEndColumn());

		assertEquals("definePackage", mdList.get(41).getName());
		assertEquals("AntClassLoader.definePackage", mdList.get(41).getModifiedName());
		assertEquals("(File container,String className)", mdList.get(41).getParams());
		assertEquals("(File,String)", mdList.get(41).getParamTypeOnly(true));
		assertEquals(1150, mdList.get(41).getStartLine());
		assertEquals(5, mdList.get(41).getStartColumn());
		assertEquals(1168, mdList.get(41).getEndLine());
		assertEquals(5, mdList.get(41).getEndColumn());

		assertEquals("getJarManifest", mdList.get(42).getName());
		assertEquals("AntClassLoader.getJarManifest", mdList.get(42).getModifiedName());
		assertEquals("(File container)", mdList.get(42).getParams());
		assertEquals("(File)", mdList.get(42).getParamTypeOnly(true));
		assertEquals(1181, mdList.get(42).getStartLine());
		assertEquals(5, mdList.get(42).getStartColumn());
		assertEquals(1190, mdList.get(42).getEndLine());
		assertEquals(5, mdList.get(42).getEndColumn());

		assertEquals("getCertificates", mdList.get(43).getName());
		assertEquals("AntClassLoader.getCertificates", mdList.get(43).getModifiedName());
		assertEquals("(File container,String entry)", mdList.get(43).getParams());
		assertEquals("(File,String)", mdList.get(43).getParamTypeOnly(true));
		assertEquals(1203, mdList.get(43).getStartLine());
		assertEquals(5, mdList.get(43).getStartColumn());
		assertEquals(1214, mdList.get(43).getEndLine());
		assertEquals(5, mdList.get(43).getEndColumn());

		assertEquals("definePackage", mdList.get(44).getName());
		assertEquals("AntClassLoader.definePackage", mdList.get(44).getModifiedName());
		assertEquals("(File container,String packageName,Manifest manifest)", mdList.get(44).getParams());
		assertEquals("(File,String,Manifest)", mdList.get(44).getParamTypeOnly(true));
		assertEquals(1224, mdList.get(44).getStartLine());
		assertEquals(5, mdList.get(44).getStartColumn());
		assertEquals(1279, mdList.get(44).getEndLine());
		assertEquals(5, mdList.get(44).getEndColumn());

		assertEquals("getClassFromStream", mdList.get(45).getName());
		assertEquals("AntClassLoader.getClassFromStream", mdList.get(45).getModifiedName());
		assertEquals("(InputStream stream,String classname,File container)", mdList.get(45).getParams());
		assertEquals("(InputStream,String,File)", mdList.get(45).getParamTypeOnly(true));
		assertEquals(1297, mdList.get(45).getStartLine());
		assertEquals(5, mdList.get(45).getStartColumn());
		assertEquals(1308, mdList.get(45).getEndLine());
		assertEquals(5, mdList.get(45).getEndColumn());

		assertEquals("findClass", mdList.get(46).getName());
		assertEquals("AntClassLoader.findClass", mdList.get(46).getModifiedName());
		assertEquals("(String name)", mdList.get(46).getParams());
		assertEquals("(String)", mdList.get(46).getParamTypeOnly(true));
		assertEquals(1321, mdList.get(46).getStartLine());
		assertEquals(5, mdList.get(46).getStartColumn());
		assertEquals(1324, mdList.get(46).getEndLine());
		assertEquals(5, mdList.get(46).getEndColumn());

		assertEquals("isInPath", mdList.get(47).getName());
		assertEquals("AntClassLoader.isInPath", mdList.get(47).getModifiedName());
		assertEquals("(File component)", mdList.get(47).getParams());
		assertEquals("(File)", mdList.get(47).getParamTypeOnly(true));
		assertEquals(1333, mdList.get(47).getStartLine());
		assertEquals(5, mdList.get(47).getStartColumn());
		assertEquals(1335, mdList.get(47).getEndLine());
		assertEquals(5, mdList.get(47).getEndColumn());

		assertEquals("findClassInComponents", mdList.get(48).getName());
		assertEquals("AntClassLoader.findClassInComponents", mdList.get(48).getModifiedName());
		assertEquals("(String name)", mdList.get(48).getParams());
		assertEquals("(String)", mdList.get(48).getParamTypeOnly(true));
		assertEquals(1348, mdList.get(48).getStartLine());
		assertEquals(5, mdList.get(48).getStartColumn());
		assertEquals(1375, mdList.get(48).getEndLine());
		assertEquals(5, mdList.get(48).getEndColumn());

		assertEquals("findBaseClass", mdList.get(49).getName());
		assertEquals("AntClassLoader.findBaseClass", mdList.get(49).getModifiedName());
		assertEquals("(String name)", mdList.get(49).getParams());
		assertEquals("(String)", mdList.get(49).getParamTypeOnly(true));
		assertEquals(1392, mdList.get(49).getStartLine());
		assertEquals(5, mdList.get(49).getStartColumn());
		assertEquals(1394, mdList.get(49).getEndLine());
		assertEquals(5, mdList.get(49).getEndColumn());

		assertEquals("cleanup", mdList.get(50).getName());
		assertEquals("AntClassLoader.cleanup", mdList.get(50).getModifiedName());
		assertEquals("()", mdList.get(50).getParams());
		assertEquals("()", mdList.get(50).getParamTypeOnly(true));
		assertEquals(1400, mdList.get(50).getStartLine());
		assertEquals(5, mdList.get(50).getStartColumn());
		assertEquals(1414, mdList.get(50).getEndLine());
		assertEquals(5, mdList.get(50).getEndColumn());

		assertEquals("getConfiguredParent", mdList.get(51).getName());
		assertEquals("AntClassLoader.getConfiguredParent", mdList.get(51).getModifiedName());
		assertEquals("()", mdList.get(51).getParams());
		assertEquals("()", mdList.get(51).getParamTypeOnly(true));
		assertEquals(1422, mdList.get(51).getStartLine());
		assertEquals(5, mdList.get(51).getStartColumn());
		assertEquals(1424, mdList.get(51).getEndLine());
		assertEquals(5, mdList.get(51).getEndColumn());

		assertEquals("buildStarted", mdList.get(52).getName());
		assertEquals("AntClassLoader.buildStarted", mdList.get(52).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(52).getParams());
		assertEquals("(BuildEvent)", mdList.get(52).getParamTypeOnly(true));
		assertEquals(1431, mdList.get(52).getStartLine());
		assertEquals(5, mdList.get(52).getStartColumn());
		assertEquals(1433, mdList.get(52).getEndLine());
		assertEquals(5, mdList.get(52).getEndColumn());

		assertEquals("buildFinished", mdList.get(53).getName());
		assertEquals("AntClassLoader.buildFinished", mdList.get(53).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(53).getParams());
		assertEquals("(BuildEvent)", mdList.get(53).getParamTypeOnly(true));
		assertEquals(1441, mdList.get(53).getStartLine());
		assertEquals(5, mdList.get(53).getStartColumn());
		assertEquals(1443, mdList.get(53).getEndLine());
		assertEquals(5, mdList.get(53).getEndColumn());

		assertEquals("subBuildFinished", mdList.get(54).getName());
		assertEquals("AntClassLoader.subBuildFinished", mdList.get(54).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(54).getParams());
		assertEquals("(BuildEvent)", mdList.get(54).getParamTypeOnly(true));
		assertEquals(1454, mdList.get(54).getStartLine());
		assertEquals(5, mdList.get(54).getStartColumn());
		assertEquals(1458, mdList.get(54).getEndLine());
		assertEquals(5, mdList.get(54).getEndColumn());

		assertEquals("subBuildStarted", mdList.get(55).getName());
		assertEquals("AntClassLoader.subBuildStarted", mdList.get(55).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(55).getParams());
		assertEquals("(BuildEvent)", mdList.get(55).getParamTypeOnly(true));
		assertEquals(1467, mdList.get(55).getStartLine());
		assertEquals(5, mdList.get(55).getStartColumn());
		assertEquals(1469, mdList.get(55).getEndLine());
		assertEquals(5, mdList.get(55).getEndColumn());

		assertEquals("targetStarted", mdList.get(56).getName());
		assertEquals("AntClassLoader.targetStarted", mdList.get(56).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(56).getParams());
		assertEquals("(BuildEvent)", mdList.get(56).getParamTypeOnly(true));
		assertEquals(1476, mdList.get(56).getStartLine());
		assertEquals(5, mdList.get(56).getStartColumn());
		assertEquals(1478, mdList.get(56).getEndLine());
		assertEquals(5, mdList.get(56).getEndColumn());

		assertEquals("targetFinished", mdList.get(57).getName());
		assertEquals("AntClassLoader.targetFinished", mdList.get(57).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(57).getParams());
		assertEquals("(BuildEvent)", mdList.get(57).getParamTypeOnly(true));
		assertEquals(1485, mdList.get(57).getStartLine());
		assertEquals(5, mdList.get(57).getStartColumn());
		assertEquals(1487, mdList.get(57).getEndLine());
		assertEquals(5, mdList.get(57).getEndColumn());

		assertEquals("taskStarted", mdList.get(58).getName());
		assertEquals("AntClassLoader.taskStarted", mdList.get(58).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(58).getParams());
		assertEquals("(BuildEvent)", mdList.get(58).getParamTypeOnly(true));
		assertEquals(1494, mdList.get(58).getStartLine());
		assertEquals(5, mdList.get(58).getStartColumn());
		assertEquals(1496, mdList.get(58).getEndLine());
		assertEquals(5, mdList.get(58).getEndColumn());

		assertEquals("taskFinished", mdList.get(59).getName());
		assertEquals("AntClassLoader.taskFinished", mdList.get(59).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(59).getParams());
		assertEquals("(BuildEvent)", mdList.get(59).getParamTypeOnly(true));
		assertEquals(1503, mdList.get(59).getStartLine());
		assertEquals(5, mdList.get(59).getStartColumn());
		assertEquals(1505, mdList.get(59).getEndLine());
		assertEquals(5, mdList.get(59).getEndColumn());

		assertEquals("messageLogged", mdList.get(60).getName());
		assertEquals("AntClassLoader.messageLogged", mdList.get(60).getModifiedName());
		assertEquals("(BuildEvent event)", mdList.get(60).getParams());
		assertEquals("(BuildEvent)", mdList.get(60).getParamTypeOnly(true));
		assertEquals(1512, mdList.get(60).getStartLine());
		assertEquals(5, mdList.get(60).getStartColumn());
		assertEquals(1514, mdList.get(60).getEndLine());
		assertEquals(5, mdList.get(60).getEndColumn());

		assertEquals("addJavaLibraries", mdList.get(61).getName());
		assertEquals("AntClassLoader.addJavaLibraries", mdList.get(61).getModifiedName());
		assertEquals("()", mdList.get(61).getParams());
		assertEquals("()", mdList.get(61).getParamTypeOnly(true));
		assertEquals(1520, mdList.get(61).getStartLine());
		assertEquals(5, mdList.get(61).getStartColumn());
		assertEquals(1527, mdList.get(61).getEndLine());
		assertEquals(5, mdList.get(61).getEndColumn());

		assertEquals("toString", mdList.get(62).getName());
		assertEquals("AntClassLoader.toString", mdList.get(62).getModifiedName());
		assertEquals("()", mdList.get(62).getParams());
		assertEquals("()", mdList.get(62).getParamTypeOnly(true));
		assertEquals(1533, mdList.get(62).getStartLine());
		assertEquals(5, mdList.get(62).getStartColumn());
		assertEquals(1535, mdList.get(62).getEndLine());
		assertEquals(5, mdList.get(62).getEndColumn());

		assertEquals("newAntClassLoader", mdList.get(63).getName());
		assertEquals("AntClassLoader.newAntClassLoader", mdList.get(63).getModifiedName());
		assertEquals("(ClassLoader parent,Project project,Path path,boolean parentFirst)", mdList.get(63).getParams());
		assertEquals("(ClassLoader,Project,Path,boolean)", mdList.get(63).getParamTypeOnly(true));
		assertEquals(1556, mdList.get(63).getStartLine());
		assertEquals(5, mdList.get(63).getStartColumn());
		assertEquals(1570, mdList.get(63).getEndLine());
		assertEquals(5, mdList.get(63).getEndColumn());

		assertEquals("isZip", mdList.get(64).getName());
		assertEquals("AntClassLoader.isZip", mdList.get(64).getModifiedName());
		assertEquals("(File file)", mdList.get(64).getParams());
		assertEquals("(File)", mdList.get(64).getParamTypeOnly(true));
		assertEquals(1576, mdList.get(64).getStartLine());
		assertEquals(5, mdList.get(64).getStartColumn());
		assertEquals(1586, mdList.get(64).getEndLine());
		assertEquals(5, mdList.get(64).getEndColumn());

		assertEquals("readFully", mdList.get(65).getName());
		assertEquals("AntClassLoader.readFully", mdList.get(65).getModifiedName());
		assertEquals("(File f,byte[] b)", mdList.get(65).getParams());
		assertEquals("(File,byte[])", mdList.get(65).getParamTypeOnly(true));
		assertEquals(1588, mdList.get(65).getStartLine());
		assertEquals(5, mdList.get(65).getStartColumn());
		assertEquals(1604, mdList.get(65).getEndLine());
		assertEquals(5, mdList.get(65).getEndColumn());
	}



	/**
	 * ComponentHelper
	 * @throws Exception
	 */
	@Test
	public void testExtractMethod02() throws Exception {
		Logger.init();

		JavaMethodExtractor jme = new JavaMethodExtractor("testfile/Application/ant/src/ComponentHelper.java");
		ArrayList<Method> mdList = jme.extractMethod();

		assertEquals(46, mdList.size());

		assertEquals("getProject", mdList.get(0).getName());
		assertEquals("ComponentHelper.getProject", mdList.get(0).getModifiedName());
		assertEquals("()", mdList.get(0).getParams());
		assertEquals("()", mdList.get(0).getParamTypeOnly(true));
		assertEquals(135, mdList.get(0).getStartLine());
		assertEquals(6, mdList.get(0).getStartColumn());
		assertEquals(137, mdList.get(0).getEndLine());
		assertEquals(6, mdList.get(0).getEndColumn());

		assertEquals("getComponentHelper", mdList.get(1).getName());
		assertEquals("ComponentHelper.getComponentHelper", mdList.get(1).getModifiedName());
		assertEquals("(Project project)", mdList.get(1).getParams());
		assertEquals("(Project)", mdList.get(1).getParamTypeOnly(true));
		assertEquals(145, mdList.get(1).getStartLine());
		assertEquals(5, mdList.get(1).getStartColumn());
		assertEquals(159, mdList.get(1).getEndLine());
		assertEquals(5, mdList.get(1).getEndColumn());

		assertEquals("ComponentHelper", mdList.get(2).getName());
		assertEquals("ComponentHelper.ComponentHelper", mdList.get(2).getModifiedName());
		assertEquals("()", mdList.get(2).getParams());
		assertEquals("()", mdList.get(2).getParamTypeOnly(true));
		assertEquals(164, mdList.get(2).getStartLine());
		assertEquals(5, mdList.get(2).getStartColumn());
		assertEquals(165, mdList.get(2).getEndLine());
		assertEquals(5, mdList.get(2).getEndColumn());

		assertEquals("setNext", mdList.get(3).getName());
		assertEquals("ComponentHelper.setNext", mdList.get(3).getModifiedName());
		assertEquals("(ComponentHelper next)", mdList.get(3).getParams());
		assertEquals("(ComponentHelper)", mdList.get(3).getParamTypeOnly(true));
		assertEquals(172, mdList.get(3).getStartLine());
		assertEquals(5, mdList.get(3).getStartColumn());
		assertEquals(174, mdList.get(3).getEndLine());
		assertEquals(5, mdList.get(3).getEndColumn());

		assertEquals("getNext", mdList.get(4).getName());
		assertEquals("ComponentHelper.getNext", mdList.get(4).getModifiedName());
		assertEquals("()", mdList.get(4).getParams());
		assertEquals("()", mdList.get(4).getParamTypeOnly(true));
		assertEquals(181, mdList.get(4).getStartLine());
		assertEquals(5, mdList.get(4).getStartColumn());
		assertEquals(183, mdList.get(4).getEndLine());
		assertEquals(5, mdList.get(4).getEndColumn());

		assertEquals("setProject", mdList.get(5).getName());
		assertEquals("ComponentHelper.setProject", mdList.get(5).getModifiedName());
		assertEquals("(Project project)", mdList.get(5).getParams());
		assertEquals("(Project)", mdList.get(5).getParamTypeOnly(true));
		assertEquals(190, mdList.get(5).getStartLine());
		assertEquals(5, mdList.get(5).getStartColumn());
		assertEquals(193, mdList.get(5).getEndLine());
		assertEquals(5, mdList.get(5).getEndColumn());

		assertEquals("getCheckedNamespace", mdList.get(6).getName());
		assertEquals("ComponentHelper.getCheckedNamespace", mdList.get(6).getModifiedName());
		assertEquals("()", mdList.get(6).getParams());
		assertEquals("()", mdList.get(6).getParamTypeOnly(true));
		assertEquals(198, mdList.get(6).getStartLine());
		assertEquals(5, mdList.get(6).getStartColumn());
		assertEquals(202, mdList.get(6).getEndLine());
		assertEquals(5, mdList.get(6).getEndColumn());

		assertEquals("getRestrictedDefinition", mdList.get(7).getName());
		assertEquals("ComponentHelper.getRestrictedDefinition", mdList.get(7).getModifiedName());
		assertEquals("()", mdList.get(7).getParams());
		assertEquals("()", mdList.get(7).getParamTypeOnly(true));
		assertEquals(207, mdList.get(7).getStartLine());
		assertEquals(5, mdList.get(7).getStartColumn());
		assertEquals(220, mdList.get(7).getEndLine());
		assertEquals(5, mdList.get(7).getEndColumn());

		assertEquals("initSubProject", mdList.get(8).getName());
		assertEquals("ComponentHelper.initSubProject", mdList.get(8).getModifiedName());
		assertEquals("(ComponentHelper helper)", mdList.get(8).getParams());
		assertEquals("(ComponentHelper)", mdList.get(8).getParamTypeOnly(true));
		assertEquals(229, mdList.get(8).getStartLine());
		assertEquals(5, mdList.get(8).getStartColumn());
		assertEquals(247, mdList.get(8).getEndLine());
		assertEquals(5, mdList.get(8).getEndColumn());

		assertEquals("createComponent", mdList.get(9).getName());
		assertEquals("ComponentHelper.createComponent", mdList.get(9).getModifiedName());
		assertEquals("(UnknownElement ue,String ns,String componentType)", mdList.get(9).getParams());
		assertEquals("(UnknownElement,String,String)", mdList.get(9).getParamTypeOnly(true));
		assertEquals(261, mdList.get(9).getStartLine());
		assertEquals(5, mdList.get(9).getStartColumn());
		assertEquals(273, mdList.get(9).getEndLine());
		assertEquals(5, mdList.get(9).getEndColumn());

		assertEquals("createComponent", mdList.get(10).getName());
		assertEquals("ComponentHelper.createComponent", mdList.get(10).getModifiedName());
		assertEquals("(String componentName)", mdList.get(10).getParams());
		assertEquals("(String)", mdList.get(10).getParamTypeOnly(true));
		assertEquals(283, mdList.get(10).getStartLine());
		assertEquals(5, mdList.get(10).getStartColumn());
		assertEquals(286, mdList.get(10).getEndLine());
		assertEquals(5, mdList.get(10).getEndColumn());

		assertEquals("getComponentClass", mdList.get(11).getName());
		assertEquals("ComponentHelper.getComponentClass", mdList.get(11).getModifiedName());
		assertEquals("(String componentName)", mdList.get(11).getParams());
		assertEquals("(String)", mdList.get(11).getParamTypeOnly(true));
		assertEquals(296, mdList.get(11).getStartLine());
		assertEquals(5, mdList.get(11).getStartColumn());
		assertEquals(299, mdList.get(11).getEndLine());
		assertEquals(5, mdList.get(11).getEndColumn());

		assertEquals("getDefinition", mdList.get(12).getName());
		assertEquals("ComponentHelper.getDefinition", mdList.get(12).getModifiedName());
		assertEquals("(String componentName)", mdList.get(12).getParams());
		assertEquals("(String)", mdList.get(12).getParamTypeOnly(true));
		assertEquals(306, mdList.get(12).getStartLine());
		assertEquals(5, mdList.get(12).getStartColumn());
		assertEquals(309, mdList.get(12).getEndLine());
		assertEquals(5, mdList.get(12).getEndColumn());

		assertEquals("initDefaultDefinitions", mdList.get(13).getName());
		assertEquals("ComponentHelper.initDefaultDefinitions", mdList.get(13).getModifiedName());
		assertEquals("()", mdList.get(13).getParams());
		assertEquals("()", mdList.get(13).getParamTypeOnly(true));
		assertEquals(316, mdList.get(13).getStartLine());
		assertEquals(5, mdList.get(13).getStartColumn());
		assertEquals(320, mdList.get(13).getEndLine());
		assertEquals(5, mdList.get(13).getEndColumn());

		assertEquals("addTaskDefinition", mdList.get(14).getName());
		assertEquals("ComponentHelper.addTaskDefinition", mdList.get(14).getModifiedName());
		assertEquals("(String taskName,Class<?> taskClass)", mdList.get(14).getParams());
		assertEquals("(String,Class)", mdList.get(14).getParamTypeOnly(true));
		assertEquals(340, mdList.get(14).getStartLine());
		assertEquals(5, mdList.get(14).getStartColumn());
		assertEquals(350, mdList.get(14).getEndLine());
		assertEquals(5, mdList.get(14).getEndColumn());

		assertEquals("checkTaskClass", mdList.get(15).getName());
		assertEquals("ComponentHelper.checkTaskClass", mdList.get(15).getModifiedName());
		assertEquals("(final Class<?> taskClass)", mdList.get(15).getParams());
		assertEquals("(Class)", mdList.get(15).getParamTypeOnly(true));
		assertEquals(364, mdList.get(15).getStartLine());
		assertEquals(5, mdList.get(15).getStartColumn());
		assertEquals(387, mdList.get(15).getEndLine());
		assertEquals(5, mdList.get(15).getEndColumn());

		assertEquals("getTaskDefinitions", mdList.get(16).getName());
		assertEquals("ComponentHelper.getTaskDefinitions", mdList.get(16).getModifiedName());
		assertEquals("()", mdList.get(16).getParams());
		assertEquals("()", mdList.get(16).getParamTypeOnly(true));
		assertEquals(397, mdList.get(16).getStartLine());
		assertEquals(5, mdList.get(16).getStartColumn());
		assertEquals(416, mdList.get(16).getEndLine());
		assertEquals(5, mdList.get(16).getEndColumn());

		assertEquals("getDataTypeDefinitions", mdList.get(17).getName());
		assertEquals("ComponentHelper.getDataTypeDefinitions", mdList.get(17).getModifiedName());
		assertEquals("()", mdList.get(17).getParams());
		assertEquals("()", mdList.get(17).getParamTypeOnly(true));
		assertEquals(425, mdList.get(17).getStartLine());
		assertEquals(5, mdList.get(17).getStartColumn());
		assertEquals(444, mdList.get(17).getEndLine());
		assertEquals(5, mdList.get(17).getEndColumn());

		assertEquals("getRestrictedDefinitions", mdList.get(18).getName());
		assertEquals("ComponentHelper.getRestrictedDefinitions", mdList.get(18).getModifiedName());
		assertEquals("(String componentName)", mdList.get(18).getParams());
		assertEquals("(String)", mdList.get(18).getParamTypeOnly(true));
		assertEquals(455, mdList.get(18).getStartLine());
		assertEquals(5, mdList.get(18).getStartColumn());
		assertEquals(459, mdList.get(18).getEndLine());
		assertEquals(5, mdList.get(18).getEndColumn());

		assertEquals("addDataTypeDefinition", mdList.get(19).getName());
		assertEquals("ComponentHelper.addDataTypeDefinition", mdList.get(19).getModifiedName());
		assertEquals("(String typeName,Class<?> typeClass)", mdList.get(19).getParams());
		assertEquals("(String,Class)", mdList.get(19).getParamTypeOnly(true));
		assertEquals(474, mdList.get(19).getStartLine());
		assertEquals(5, mdList.get(19).getStartColumn());
		assertEquals(481, mdList.get(19).getEndLine());
		assertEquals(5, mdList.get(19).getEndColumn());

		assertEquals("addDataTypeDefinition", mdList.get(20).getName());
		assertEquals("ComponentHelper.addDataTypeDefinition", mdList.get(20).getModifiedName());
		assertEquals("(AntTypeDefinition def)", mdList.get(20).getParams());
		assertEquals("(AntTypeDefinition)", mdList.get(20).getParamTypeOnly(true));
		assertEquals(488, mdList.get(20).getStartLine());
		assertEquals(5, mdList.get(20).getStartColumn());
		assertEquals(494, mdList.get(20).getEndLine());
		assertEquals(5, mdList.get(20).getEndColumn());

		assertEquals("getAntTypeTable", mdList.get(21).getName());
		assertEquals("ComponentHelper.getAntTypeTable", mdList.get(21).getModifiedName());
		assertEquals("()", mdList.get(21).getParams());
		assertEquals("()", mdList.get(21).getParamTypeOnly(true));
		assertEquals(503, mdList.get(21).getStartLine());
		assertEquals(5, mdList.get(21).getStartColumn());
		assertEquals(505, mdList.get(21).getEndLine());
		assertEquals(5, mdList.get(21).getEndColumn());

		assertEquals("createTask", mdList.get(22).getName());
		assertEquals("ComponentHelper.createTask", mdList.get(22).getModifiedName());
		assertEquals("(String taskType)", mdList.get(22).getParams());
		assertEquals("(String)", mdList.get(22).getParamTypeOnly(true));
		assertEquals(521, mdList.get(22).getStartLine());
		assertEquals(5, mdList.get(22).getStartColumn());
		assertEquals(530, mdList.get(22).getEndLine());
		assertEquals(5, mdList.get(22).getEndColumn());

		assertEquals("createNewTask", mdList.get(23).getName());
		assertEquals("ComponentHelper.createNewTask", mdList.get(23).getModifiedName());
		assertEquals("(String taskType)", mdList.get(23).getParams());
		assertEquals("(String)", mdList.get(23).getParamTypeOnly(true));
		assertEquals(544, mdList.get(23).getStartLine());
		assertEquals(5, mdList.get(23).getStartColumn());
		assertEquals(565, mdList.get(23).getEndLine());
		assertEquals(5, mdList.get(23).getEndColumn());

		assertEquals("createDataType", mdList.get(24).getName());
		assertEquals("ComponentHelper.createDataType", mdList.get(24).getModifiedName());
		assertEquals("(String typeName)", mdList.get(24).getParams());
		assertEquals("(String)", mdList.get(24).getParamTypeOnly(true));
		assertEquals(579, mdList.get(24).getStartLine());
		assertEquals(5, mdList.get(24).getStartColumn());
		assertEquals(581, mdList.get(24).getEndLine());
		assertEquals(5, mdList.get(24).getEndColumn());

		assertEquals("getElementName", mdList.get(25).getName());
		assertEquals("ComponentHelper.getElementName", mdList.get(25).getModifiedName());
		assertEquals("(Object element)", mdList.get(25).getParams());
		assertEquals("(Object)", mdList.get(25).getParamTypeOnly(true));
		assertEquals(595, mdList.get(25).getStartLine());
		assertEquals(5, mdList.get(25).getStartColumn());
		assertEquals(597, mdList.get(25).getEndLine());
		assertEquals(5, mdList.get(25).getEndColumn());

		assertEquals("getElementName", mdList.get(26).getName());
		assertEquals("ComponentHelper.getElementName", mdList.get(26).getModifiedName());
		assertEquals("(Object o,boolean brief)", mdList.get(26).getParams());
		assertEquals("(Object,boolean)", mdList.get(26).getParamTypeOnly(true));
		assertEquals(611, mdList.get(26).getStartLine());
		assertEquals(5, mdList.get(26).getStartColumn());
		assertEquals(627, mdList.get(26).getEndLine());
		assertEquals(5, mdList.get(26).getEndColumn());

		assertEquals("getElementName", mdList.get(27).getName());
		assertEquals("ComponentHelper.getElementName", mdList.get(27).getModifiedName());
		assertEquals("(Project p,Object o,boolean brief)", mdList.get(27).getParams());
		assertEquals("(Project,Object,boolean)", mdList.get(27).getParamTypeOnly(true));
		assertEquals(639, mdList.get(27).getStartLine());
		assertEquals(5, mdList.get(27).getStartColumn());
		assertEquals(645, mdList.get(27).getEndLine());
		assertEquals(5, mdList.get(27).getEndColumn());

		assertEquals("getUnmappedElementName", mdList.get(28).getName());
		assertEquals("ComponentHelper.getUnmappedElementName", mdList.get(28).getModifiedName());
		assertEquals("(Class<?> c,boolean brief)", mdList.get(28).getParams());
		assertEquals("(Class,boolean)", mdList.get(28).getParamTypeOnly(true));
		assertEquals(647, mdList.get(28).getStartLine());
		assertEquals(5, mdList.get(28).getStartColumn());
		assertEquals(653, mdList.get(28).getEndLine());
		assertEquals(5, mdList.get(28).getEndColumn());

		assertEquals("validDefinition", mdList.get(29).getName());
		assertEquals("ComponentHelper.validDefinition", mdList.get(29).getModifiedName());
		assertEquals("(AntTypeDefinition def)", mdList.get(29).getParams());
		assertEquals("(AntTypeDefinition)", mdList.get(29).getParamTypeOnly(true));
		assertEquals(661, mdList.get(29).getStartLine());
		assertEquals(5, mdList.get(29).getStartColumn());
		assertEquals(663, mdList.get(29).getEndLine());
		assertEquals(5, mdList.get(29).getEndColumn());

		assertEquals("sameDefinition", mdList.get(30).getName());
		assertEquals("ComponentHelper.sameDefinition", mdList.get(30).getModifiedName());
		assertEquals("(AntTypeDefinition def,AntTypeDefinition old)", mdList.get(30).getParams());
		assertEquals("(AntTypeDefinition,AntTypeDefinition)", mdList.get(30).getParamTypeOnly(true));
		assertEquals(671, mdList.get(30).getStartLine());
		assertEquals(5, mdList.get(30).getStartColumn());
		assertEquals(676, mdList.get(30).getEndLine());
		assertEquals(5, mdList.get(30).getEndColumn());

		assertEquals("updateRestrictedDefinition", mdList.get(31).getName());
		assertEquals("ComponentHelper.updateRestrictedDefinition", mdList.get(31).getModifiedName());
		assertEquals("(AntTypeDefinition def)", mdList.get(31).getParams());
		assertEquals("(AntTypeDefinition)", mdList.get(31).getParamTypeOnly(true));
		assertEquals(682, mdList.get(31).getStartLine());
		assertEquals(5, mdList.get(31).getStartColumn());
		assertEquals(704, mdList.get(31).getEndLine());
		assertEquals(5, mdList.get(31).getEndColumn());

		assertEquals("updateDataTypeDefinition", mdList.get(32).getName());
		assertEquals("ComponentHelper.updateDataTypeDefinition", mdList.get(32).getModifiedName());
		assertEquals("(AntTypeDefinition def)", mdList.get(32).getParams());
		assertEquals("(AntTypeDefinition)", mdList.get(32).getParamTypeOnly(true));
		assertEquals(711, mdList.get(32).getStartLine());
		assertEquals(5, mdList.get(32).getStartColumn());
		assertEquals(730, mdList.get(32).getEndLine());
		assertEquals(5, mdList.get(32).getEndColumn());

		assertEquals("enterAntLib", mdList.get(33).getName());
		assertEquals("ComponentHelper.enterAntLib", mdList.get(33).getModifiedName());
		assertEquals("(String uri)", mdList.get(33).getParams());
		assertEquals("(String)", mdList.get(33).getParamTypeOnly(true));
		assertEquals(736, mdList.get(33).getStartLine());
		assertEquals(5, mdList.get(33).getStartColumn());
		assertEquals(739, mdList.get(33).getEndLine());
		assertEquals(5, mdList.get(33).getEndColumn());

		assertEquals("getCurrentAntlibUri", mdList.get(34).getName());
		assertEquals("ComponentHelper.getCurrentAntlibUri", mdList.get(34).getModifiedName());
		assertEquals("()", mdList.get(34).getParams());
		assertEquals("()", mdList.get(34).getParamTypeOnly(true));
		assertEquals(744, mdList.get(34).getStartLine());
		assertEquals(5, mdList.get(34).getStartColumn());
		assertEquals(746, mdList.get(34).getEndLine());
		assertEquals(5, mdList.get(34).getEndColumn());

		assertEquals("exitAntLib", mdList.get(35).getName());
		assertEquals("ComponentHelper.exitAntLib", mdList.get(35).getModifiedName());
		assertEquals("()", mdList.get(35).getParams());
		assertEquals("()", mdList.get(35).getParamTypeOnly(true));
		assertEquals(751, mdList.get(35).getStartLine());
		assertEquals(5, mdList.get(35).getStartColumn());
		assertEquals(754, mdList.get(35).getEndLine());
		assertEquals(5, mdList.get(35).getEndColumn());

		assertEquals("initTasks", mdList.get(36).getName());
		assertEquals("ComponentHelper.initTasks", mdList.get(36).getModifiedName());
		assertEquals("()", mdList.get(36).getParams());
		assertEquals("()", mdList.get(36).getParamTypeOnly(true));
		assertEquals(759, mdList.get(36).getStartLine());
		assertEquals(5, mdList.get(36).getStartColumn());
		assertEquals(774, mdList.get(36).getEndLine());
		assertEquals(5, mdList.get(36).getEndColumn());

		assertEquals("getClassLoader", mdList.get(37).getName());
		assertEquals("ComponentHelper.getClassLoader", mdList.get(37).getModifiedName());
		assertEquals("(ClassLoader classLoader)", mdList.get(37).getParams());
		assertEquals("(ClassLoader)", mdList.get(37).getParamTypeOnly(true));
		assertEquals(776, mdList.get(37).getStartLine());
		assertEquals(5, mdList.get(37).getStartColumn());
		assertEquals(783, mdList.get(37).getEndLine());
		assertEquals(5, mdList.get(37).getEndColumn());

		assertEquals("getDefaultDefinitions", mdList.get(38).getName());
		assertEquals("ComponentHelper.getDefaultDefinitions", mdList.get(38).getModifiedName());
		assertEquals("(boolean type)", mdList.get(38).getParams());
		assertEquals("(boolean)", mdList.get(38).getParamTypeOnly(true));
		assertEquals(794, mdList.get(38).getStartLine());
		assertEquals(5, mdList.get(38).getStartColumn());
		assertEquals(817, mdList.get(38).getEndLine());
		assertEquals(5, mdList.get(38).getEndColumn());

		assertEquals("initTypes", mdList.get(39).getName());
		assertEquals("ComponentHelper.initTypes", mdList.get(39).getModifiedName());
		assertEquals("()", mdList.get(39).getParams());
		assertEquals("()", mdList.get(39).getParamTypeOnly(true));
		assertEquals(822, mdList.get(39).getStartLine());
		assertEquals(5, mdList.get(39).getStartColumn());
		assertEquals(835, mdList.get(39).getEndLine());
		assertEquals(5, mdList.get(39).getEndColumn());

		assertEquals("checkNamespace", mdList.get(40).getName());
		assertEquals("ComponentHelper.checkNamespace", mdList.get(40).getModifiedName());
		assertEquals("(String componentName)", mdList.get(40).getParams());
		assertEquals("(String)", mdList.get(40).getParamTypeOnly(true));
		assertEquals(843, mdList.get(40).getStartLine());
		assertEquals(5, mdList.get(40).getStartColumn());
		assertEquals(875, mdList.get(40).getEndLine());
		assertEquals(5, mdList.get(40).getEndColumn());

		assertEquals("diagnoseCreationFailure", mdList.get(41).getName());
		assertEquals("ComponentHelper.diagnoseCreationFailure", mdList.get(41).getModifiedName());
		assertEquals("(String componentName,String type)", mdList.get(41).getParams());
		assertEquals("(String,String)", mdList.get(41).getParamTypeOnly(true));
		assertEquals(883, mdList.get(41).getStartLine());
		assertEquals(5, mdList.get(41).getStartColumn());
		assertEquals(1014, mdList.get(41).getEndLine());
		assertEquals(5, mdList.get(41).getEndColumn());

		assertEquals("printUnknownDefinition", mdList.get(42).getName());
		assertEquals("ComponentHelper.printUnknownDefinition", mdList.get(42).getModifiedName());
		assertEquals("(PrintWriter out,String componentName,String dirListing)", mdList.get(42).getParams());
		assertEquals("(PrintWriter,String,String)", mdList.get(42).getParamTypeOnly(true));
		assertEquals(1019, mdList.get(42).getStartLine());
		assertEquals(5, mdList.get(42).getStartColumn());
		assertEquals(1046, mdList.get(42).getEndLine());
		assertEquals(5, mdList.get(42).getEndColumn());

		assertEquals("printClassNotFound", mdList.get(43).getName());
		assertEquals("ComponentHelper.printClassNotFound", mdList.get(43).getModifiedName());
		assertEquals("(PrintWriter out,String classname,boolean optional,String dirListing)", mdList.get(43).getParams());
		assertEquals("(PrintWriter,String,boolean,String)", mdList.get(43).getParamTypeOnly(true));
		assertEquals(1051, mdList.get(43).getStartLine());
		assertEquals(5, mdList.get(43).getStartColumn());
		assertEquals(1063, mdList.get(43).getEndLine());
		assertEquals(5, mdList.get(43).getEndColumn());

		assertEquals("printNotLoadDependentClass", mdList.get(44).getName());
		assertEquals("ComponentHelper.printNotLoadDependentClass", mdList.get(44).getModifiedName());
		assertEquals("(PrintWriter out,boolean optional,NoClassDefFoundError ncdfe,String dirListing)", mdList.get(44).getParams());
		assertEquals("(PrintWriter,boolean,NoClassDefFoundError,String)", mdList.get(44).getParamTypeOnly(true));
		assertEquals(1068, mdList.get(44).getStartLine());
		assertEquals(5, mdList.get(44).getStartColumn());
		assertEquals(1082, mdList.get(44).getEndLine());
		assertEquals(5, mdList.get(44).getEndColumn());

		assertEquals("findTypeMatches", mdList.get(45).getName());
		assertEquals("ComponentHelper.findTypeMatches", mdList.get(45).getModifiedName());
		assertEquals("(String prefix)", mdList.get(45).getParams());
		assertEquals("(String)", mdList.get(45).getParamTypeOnly(true));
		assertEquals(1090, mdList.get(45).getStartLine());
		assertEquals(5, mdList.get(45).getStartColumn());
		assertEquals(1100, mdList.get(45).getEndLine());
		assertEquals(5, mdList.get(45).getEndColumn());
	}



	/**
	 * LineOrientedOutputStream
	 * @throws Exception
	 */
	@Test
	public void testExtractMethod03() throws Exception {
		Logger.init();

		JavaMethodExtractor jme = new JavaMethodExtractor("testfile/Application/ant/src/util/LineOrientedOutputStream.java");
		ArrayList<Method> mdList = jme.extractMethod();

		assertEquals(6, mdList.size());

		assertEquals("write", mdList.get(0).getName());
		assertEquals("LineOrientedOutputStream.write", mdList.get(0).getModifiedName());
		assertEquals("(int cc)", mdList.get(0).getParams());
		assertEquals("(int)", mdList.get(0).getParamTypeOnly(true));
		assertEquals(53, mdList.get(0).getStartLine());
		assertEquals(5, mdList.get(0).getStartColumn());
		assertEquals(63, mdList.get(0).getEndLine());
		assertEquals(5, mdList.get(0).getEndColumn());

		assertEquals("flush", mdList.get(1).getName());
		assertEquals("LineOrientedOutputStream.flush", mdList.get(1).getModifiedName());
		assertEquals("()", mdList.get(1).getParams());
		assertEquals("()", mdList.get(1).getParamTypeOnly(true));
		assertEquals(69, mdList.get(1).getStartLine());
		assertEquals(5, mdList.get(1).getStartColumn());
		assertEquals(70, mdList.get(1).getEndLine());
		assertEquals(5, mdList.get(1).getEndColumn());

		assertEquals("processBuffer", mdList.get(2).getName());
		assertEquals("LineOrientedOutputStream.processBuffer", mdList.get(2).getModifiedName());
		assertEquals("()", mdList.get(2).getParams());
		assertEquals("()", mdList.get(2).getParamTypeOnly(true));
		assertEquals(77, mdList.get(2).getStartLine());
		assertEquals(5, mdList.get(2).getStartColumn());
		assertEquals(83, mdList.get(2).getEndLine());
		assertEquals(5, mdList.get(2).getEndColumn());

		assertEquals("processLine", mdList.get(3).getName());
		assertEquals("LineOrientedOutputStream.processLine", mdList.get(3).getModifiedName());
		assertEquals("(byte[] line)", mdList.get(3).getParams());
		assertEquals("(byte[])", mdList.get(3).getParamTypeOnly(true));
		assertEquals(106, mdList.get(3).getStartLine());
		assertEquals(5, mdList.get(3).getStartColumn());
		assertEquals(108, mdList.get(3).getEndLine());
		assertEquals(5, mdList.get(3).getEndColumn());

		assertEquals("close", mdList.get(4).getName());
		assertEquals("LineOrientedOutputStream.close", mdList.get(4).getModifiedName());
		assertEquals("()", mdList.get(4).getParams());
		assertEquals("()", mdList.get(4).getParamTypeOnly(true));
		assertEquals(114, mdList.get(4).getStartLine());
		assertEquals(5, mdList.get(4).getStartColumn());
		assertEquals(119, mdList.get(4).getEndLine());
		assertEquals(5, mdList.get(4).getEndColumn());

		assertEquals("write", mdList.get(5).getName());
		assertEquals("LineOrientedOutputStream.write", mdList.get(5).getModifiedName());
		assertEquals("(byte[] b,int off,int len)", mdList.get(5).getParams());
		assertEquals("(byte[],int,int)", mdList.get(5).getParamTypeOnly(true));
		assertEquals(130, mdList.get(5).getStartLine());
		assertEquals(5, mdList.get(5).getStartColumn());
		assertEquals(152, mdList.get(5).getEndLine());
		assertEquals(5, mdList.get(5).getEndColumn());
	}
}

