package jp.ac.osaka_u.ist.sel.y_yuuki.cn;

import static org.junit.Assert.*;

import java.util.ArrayList;

import jp.ac.osaka_u.ist.sel.y_yuuki.cn.data.Project;

import org.junit.Test;

public class SettingFileLoaderTest {

	/*
	 * :
	 *   String settingFile: t@C ݂ / ݂Ȃ
	 *   Project project: vWFNg null / null ȊO
	 *
	 * Ԃl:
	 *   true:
	 *   false: "NEW_VERSION" fBNg ݂Ȃ / w "src" fBNgȂ
	 *          "OLD_VERSION" fBNg ݂Ȃ / w "src" fBNgȂ
	 *          "TOOL""LANGUAGE"̑ΉȂ
	 *
	 * O:
	 *   IO: settingFile ǂݎs(`FbN)
	 *   FileNotFound: settingFile ݂Ȃ
	 */

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest01() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting01.conf", proj);

		assertTrue(result);

		assertEquals("test01", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("java", proj.getLang());
		assertTrue(proj.isCheckout());
		assertEquals("svn co xxx yyy", proj.getCheckoutCmd());
		assertEquals("old\\test01", proj.getOldDir());
		assertEquals("codir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertFalse(proj.isOlFilter());
		assertEquals(null, proj.getGenerateTextDir());
		assertFalse(proj.isGenerateText());
		assertEquals(null, proj.getGenerateHTMLDir());
		assertFalse(proj.isGenerateHtml());
		assertEquals(null, proj.getGenerateCSVDir());
		assertFalse(proj.isGenerateCSV());
		assertEquals(null, proj.getAccountFile());
		assertEquals(null, proj.getKeyFile());
		assertEquals(null, proj.getHost());
		assertEquals(0, proj.getPort());
		assertEquals(null, proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(0, list.size());

		assertEquals(0, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest02() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting02.conf", proj);

		assertTrue(result);

		assertEquals("test02", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("c", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(30, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(0, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest03() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting03.conf", proj);

		assertTrue(result);

		assertEquals("test03", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("java", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(1, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest04() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting04.conf", proj);

		assertTrue(result);

		assertEquals("test04", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("cpp", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(2, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest05() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting05.conf", proj);

		assertTrue(result);

		assertEquals("test05", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("cobol", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(1, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest06() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting06.conf", proj);

		assertTrue(result);

		assertEquals("test06", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("csharp", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(1, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest07() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting07.conf", proj);

		assertTrue(result);

		assertEquals("test07", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("visualbasic", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(1, proj.getSsl());
	}

	/**
	 * s
	 */
	@Test
	public void loadSettingFileTest08() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting08.conf", proj);

		assertTrue(result);

		assertEquals("test08", proj.getName());
		assertEquals("CCFinderX", proj.getTool());
		assertEquals("plaintext", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(50, proj.getTokenTh());
		assertTrue(proj.isOlFilter());
		assertEquals("textdir", proj.getGenerateTextDir());
		assertTrue(proj.isGenerateText());
		assertEquals("htmldir", proj.getGenerateHTMLDir());
		assertTrue(proj.isGenerateHtml());
		assertEquals("csvdir", proj.getGenerateCSVDir());
		assertTrue(proj.isGenerateCSV());
		assertEquals("account", proj.getAccountFile());
		assertEquals("key", proj.getKeyFile());
		assertEquals("smtp.server", proj.getHost());
		assertEquals(9999, proj.getPort());
		assertEquals("from@xxx.ne.jp", proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(3, list.size());
		assertEquals("to1@xxx.ne.jp", list.get(0));
		assertEquals("to2@xxx.ne.jp", list.get(1));
		assertEquals("NULL", list.get(2));

		assertEquals(1, proj.getSsl());
	}

	/**
	 * ُs. NEWDIR ݂Ȃ.
	 */
	@Test
	public void loadSettingFileTest09() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting09.conf", proj);

		assertFalse(result);

		assertEquals("test09", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("java", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals(null, proj.getOldDir());
		assertEquals("testfile\\newdir_nonexist", proj.getNewDir());
		assertEquals(0, proj.getTokenTh());
		assertFalse(proj.isOlFilter());
		assertEquals(null, proj.getGenerateTextDir());
		assertFalse(proj.isGenerateText());
		assertEquals(null, proj.getGenerateHTMLDir());
		assertFalse(proj.isGenerateHtml());
		assertEquals(null, proj.getGenerateCSVDir());
		assertFalse(proj.isGenerateCSV());
		assertEquals(null, proj.getAccountFile());
		assertEquals(null, proj.getKeyFile());
		assertEquals(null, proj.getHost());
		assertEquals(0, proj.getPort());
		assertEquals(null, proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(0, list.size());

		assertEquals(0, proj.getSsl());
	}

	/**
	 * ُs. OLDDIR ݂Ȃ.
	 */
	@Test
	public void loadSettingFileTest10() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting10.conf", proj);

		assertFalse(result);

		assertEquals("test10", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("java", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir_nonexist", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(0, proj.getTokenTh());
		assertFalse(proj.isOlFilter());
		assertEquals(null, proj.getGenerateTextDir());
		assertFalse(proj.isGenerateText());
		assertEquals(null, proj.getGenerateHTMLDir());
		assertFalse(proj.isGenerateHtml());
		assertEquals(null, proj.getGenerateCSVDir());
		assertFalse(proj.isGenerateCSV());
		assertEquals(null, proj.getAccountFile());
		assertEquals(null, proj.getKeyFile());
		assertEquals(null, proj.getHost());
		assertEquals(0, proj.getPort());
		assertEquals(null, proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(0, list.size());

		assertEquals(0, proj.getSsl());
	}

	/**
	 * ُs. NEWDIR  src ݂Ȃ.
	 */
	@Test
	public void loadSettingFileTest11() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting11.conf", proj);

		assertFalse(result);

		assertEquals("test11", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("java", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals(null, proj.getOldDir());
		assertEquals("testfile\\newdir_nonsrc", proj.getNewDir());
		assertEquals(0, proj.getTokenTh());
		assertFalse(proj.isOlFilter());
		assertEquals(null, proj.getGenerateTextDir());
		assertFalse(proj.isGenerateText());
		assertEquals(null, proj.getGenerateHTMLDir());
		assertFalse(proj.isGenerateHtml());
		assertEquals(null, proj.getGenerateCSVDir());
		assertFalse(proj.isGenerateCSV());
		assertEquals(null, proj.getAccountFile());
		assertEquals(null, proj.getKeyFile());
		assertEquals(null, proj.getHost());
		assertEquals(0, proj.getPort());
		assertEquals(null, proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(0, list.size());

		assertEquals(0, proj.getSsl());
	}

	/**
	 * ُs. OLDDIR  src ݂Ȃ.
	 */
	@Test
	public void loadSettingFileTest12() throws Exception {
		Project proj = new Project();
		boolean result = SettingFileLoader.loadSettingFile("testfile/setting12.conf", proj);

		assertFalse(result);

		assertEquals("test12", proj.getName());
		assertEquals("CloneDetector", proj.getTool());
		assertEquals("java", proj.getLang());
		assertFalse(proj.isCheckout());
		assertEquals(null, proj.getCheckoutCmd());
		assertEquals("testfile\\olddir_nonsrc", proj.getOldDir());
		assertEquals("testfile\\newdir", proj.getNewDir());
		assertEquals(0, proj.getTokenTh());
		assertFalse(proj.isOlFilter());
		assertEquals(null, proj.getGenerateTextDir());
		assertFalse(proj.isGenerateText());
		assertEquals(null, proj.getGenerateHTMLDir());
		assertFalse(proj.isGenerateHtml());
		assertEquals(null, proj.getGenerateCSVDir());
		assertFalse(proj.isGenerateCSV());
		assertEquals(null, proj.getAccountFile());
		assertEquals(null, proj.getKeyFile());
		assertEquals(null, proj.getHost());
		assertEquals(0, proj.getPort());
		assertEquals(null, proj.getFrom());

		ArrayList<String> list = proj.getToList();
		assertEquals(0, list.size());

		assertEquals(0, proj.getSsl());
	}
}
