

typedef int Py_ssize_t;





typedef struct tagPyCArgObject PyCArgObject;
typedef struct tagCDataObject CDataObject;
typedef PyObject *(* GETFUNC)(void *, unsigned size);
typedef PyObject *(* SETFUNC)(void *, PyObject *value, unsigned size);
typedef PyCArgObject *(* PARAMFUNC)(CDataObject *obj);


union value {
		char c[16];
		short s;
		int i;
		long l;
		float f;
		double d;
		PY_LONG_LONG ll;
};



struct tagCDataObject {
	PyObject_HEAD
	char *b_ptr;		
	int  b_needsfree;	
	CDataObject *b_base;	
	Py_ssize_t b_size;	
	Py_ssize_t b_length;	
	Py_ssize_t b_index;	
	PyObject *b_objects;	
	union value b_value;
};

typedef struct {
	ffi_closure *pcl; 
	ffi_cif cif;
	PyObject *converters;
	PyObject *callable;
	SETFUNC setfunc;
	ffi_type *restype;
	ffi_type *atypes[0];
} ffi_info;

typedef struct {
	
	PyObject_HEAD
	char *b_ptr;		
	int  b_needsfree;	
	CDataObject *b_base;	
	Py_ssize_t b_size;	
	Py_ssize_t b_length;	
	Py_ssize_t b_index;	
	PyObject *b_objects;	
	union value b_value;
	

	ffi_info *thunk;
	PyObject *callable;

	
	PyObject *converters;
	PyObject *argtypes;
	PyObject *restype;
	PyObject *checker;
	PyObject *errcheck;
	int index;
	GUID *iid;
	PyObject *paramflags;
} CFuncPtrObject;

extern PyTypeObject StgDict_Type;

extern int StructUnionType_update_stgdict(PyObject *fields, PyObject *type, int isStruct);
extern int PyType_stginfo(PyTypeObject *self, Py_ssize_t *psize, Py_ssize_t *palign, Py_ssize_t *plength);
extern int PyObject_stginfo(PyObject *self, Py_ssize_t *psize, Py_ssize_t *palign, Py_ssize_t *plength);



extern PyTypeObject CData_Type;

extern PyTypeObject SimpleType_Type;

extern PyTypeObject CField_Type;
extern struct fielddesc *getentry(char *fmt);


extern PyObject *
CField_FromDesc(PyObject *desc, int index,
		int *pfield_size, int bitsize, int *pbitofs,
		int *psize, int *poffset, int *palign,
		int pack, int is_big_endian);

extern PyObject *CData_AtAddress(PyObject *type, void *buf);
extern PyObject *CData_FromBytes(PyObject *type, char *data, Py_ssize_t length);

extern PyTypeObject ArrayType_Type;
extern PyTypeObject Array_Type;
extern PyTypeObject PointerType_Type;
extern PyTypeObject Pointer_Type;
extern PyTypeObject CFuncPtr_Type;
extern PyTypeObject CFuncPtrType_Type;
extern PyTypeObject StructType_Type;


extern PyObject *
CreateArrayType(PyObject *itemtype, Py_ssize_t length);

extern void init_callbacks_in_module(PyObject *m);

extern PyMethodDef module_methods[];

extern ffi_info *AllocFunctionCallback(PyObject *callable,
				       PyObject *converters,
				       PyObject *restype,
				       int stdcall);

struct fielddesc {
	char code;
	SETFUNC setfunc;
	GETFUNC getfunc;
	ffi_type *pffi_type; 
	SETFUNC setfunc_swapped;
	GETFUNC getfunc_swapped;
};

typedef struct {
	PyObject_HEAD
	Py_ssize_t offset;
	Py_ssize_t size;
	Py_ssize_t index;		
	PyObject *proto;		
	GETFUNC getfunc;		
	SETFUNC setfunc;		
	int anonymous;
} CFieldObject;


typedef struct {
	PyDictObject dict;	

	Py_ssize_t size;	
	Py_ssize_t align;	
	Py_ssize_t length;	
	ffi_type ffi_type_pointer;
	PyObject *proto;	
	SETFUNC setfunc;	
	GETFUNC getfunc;	
	PARAMFUNC paramfunc;

	
	PyObject *argtypes;	
	PyObject *converters;	
	PyObject *restype;	
	PyObject *checker;
	int flags;		
} StgDictObject;




extern StgDictObject *PyType_stgdict(PyObject *obj);


extern StgDictObject *PyObject_stgdict(PyObject *self);

extern int StgDict_clone(StgDictObject *src, StgDictObject *dst);

typedef int(* PPROC)(void);

PyObject *_CallProc(PPROC pProc,
		    PyObject *arguments,
		    IUnknown *pIUnk,
		    GUID *iid,
		    int flags,
		    PyObject *argtypes,
		    PyObject *restype,
		    PyObject *checker);
 



struct tagPyCArgObject {
	PyObject_HEAD
	ffi_type *pffi_type;
	char tag;
	union {
		char c;
		char b;
		short h;
		int i;
		long l;
		PY_LONG_LONG q;
		double d;
		float f;
		void *p;
	} value;
	PyObject *obj;
	int size; 
};

extern PyTypeObject PyCArg_Type;
extern PyCArgObject *new_CArgObject(void);
extern PyCArgObject *new_CArgObject(void);

extern PyObject *
CData_get(PyObject *type, GETFUNC getfunc, PyObject *src,
	  Py_ssize_t index, Py_ssize_t size, char *ptr);

extern int
CData_set(PyObject *dst, PyObject *type, SETFUNC setfunc, PyObject *value,
	  Py_ssize_t index, Py_ssize_t size, char *ptr);

extern void Extend_Error_Info(PyObject *exc_class, char *fmt, ...);

struct basespec {
	CDataObject *base;
	Py_ssize_t index;
	char *adr;
};

extern char basespec_string[];

extern ffi_type *GetType(PyObject *obj);


extern PyObject *PyExc_ArgError;

extern char *conversion_mode_encoding;
extern char *conversion_mode_errors;



        do {                            	\
                if (op) {			\
                        PyObject *tmp = (PyObject *)(op);	\
                        (op) = NULL;		\
                        Py_DECREF(tmp);		\
                }				\
        } while (0)


        do { 						\
                if (op) {				\
                        int vret = visit((op), arg);	\
                        if (vret)			\
                                return vret;		\
                }					\
        } while (0)






extern PyObject *My_PyUnicode_FromWideChar(const wchar_t *, Py_ssize_t);
extern int My_PyUnicode_AsWideChar(PyUnicodeObject *, wchar_t *, Py_ssize_t);


extern void FreeClosure(void *);
extern void *MallocClosure(void);

extern void _AddTraceback(char *, char *, int);

extern PyObject *CData_FromBaseObj(PyObject *type, PyObject *base, Py_ssize_t index, char *adr);


extern int IsSimpleSubType(PyObject *obj);


extern PyObject *ComError;


