








static ffi_status initialize_aggregate(
{
  ffi_type **ptr; 

  FFI_ASSERT(arg != NULL);

  

  FFI_ASSERT(arg->elements != NULL);
  FFI_ASSERT(arg->size == 0);
  FFI_ASSERT(arg->alignment == 0);

  ptr = &(arg->elements[0]);

  while ((*ptr) != NULL)
    {
      if (((*ptr)->size == 0) && (initialize_aggregate((*ptr)) != FFI_OK))
	return FFI_BAD_TYPEDEF;
      
      
      FFI_ASSERT_VALID_TYPE(*ptr);

      {
	      int curalign;

	      curalign = (*ptr)->alignment;
	      if (ptr != &(arg->elements[0])) {
		      if (curalign > 4 && curalign != 16) {
			      curalign = 4;
		      }
	      }
      arg->size = ALIGN(arg->size, curalign);
      arg->size += (*ptr)->size;

      arg->alignment = (arg->alignment > curalign) ? 
	      arg->alignment : curalign;
      }
      arg->size = ALIGN(arg->size, (*ptr)->alignment);
      arg->size += (*ptr)->size;

      arg->alignment = (arg->alignment > (*ptr)->alignment) ? 
	arg->alignment : (*ptr)->alignment;

      ptr++;
    }

  
  arg->size = ALIGN (arg->size, arg->alignment);

  if (arg->size == 0)
    return FFI_BAD_TYPEDEF;
  else
    return FFI_OK;

  
}





static inline int struct_on_stack(int size)
{
	if (size > 8) return 1;
	
	switch (size) {
	case 1: case 2: case 4: case 8: return 0;
	}
	return 1;
}


ffi_status ffi_prep_cif(
			ffi_abi abi, unsigned int nargs, 
			
			
{
  unsigned bytes = 0;
  unsigned int i;
  ffi_type **ptr;

  FFI_ASSERT(cif != NULL);
  FFI_ASSERT((abi > FFI_FIRST_ABI) && (abi <= FFI_DEFAULT_ABI));

  cif->abi = abi;
  cif->arg_types = atypes;
  cif->nargs = nargs;
  cif->rtype = rtype;

  cif->flags = 0;

  
  
  if ((cif->rtype->size == 0) && (initialize_aggregate(cif->rtype) != FFI_OK))
    return FFI_BAD_TYPEDEF;
  

  
  FFI_ASSERT_VALID_TYPE(cif->rtype);

  
  
  if (cif->rtype->type == FFI_TYPE_STRUCT
      && (cif->abi != FFI_V9 || cif->rtype->size > 32)

      && (struct_on_stack(cif->rtype->size))
      )
    bytes = STACK_ARG_SIZE(sizeof(void*));

  for (ptr = cif->arg_types, i = cif->nargs; i > 0; i--, ptr++)
    {

      
      if (((*ptr)->size == 0) && (initialize_aggregate((*ptr)) != FFI_OK))
	return FFI_BAD_TYPEDEF;

      
      FFI_ASSERT_VALID_TYPE(*ptr);

      {
	      int align = (*ptr)->alignment;
	      if (align > 4) align = 4;
	      if ((align - 1) & bytes)
		 bytes = ALIGN(bytes, align);
	      bytes += STACK_ARG_SIZE((*ptr)->size);
      }

      if (((*ptr)->type == FFI_TYPE_STRUCT
	   && ((*ptr)->size > 16 || cif->abi != FFI_V9))
	  || ((*ptr)->type == FFI_TYPE_LONGDOUBLE
	      && cif->abi != FFI_V9))
	bytes += sizeof(void*);
      else
	{
	  
	  if (((*ptr)->alignment - 1) & bytes)
	    bytes = ALIGN(bytes, (*ptr)->alignment);
	  
	  bytes += STACK_ARG_SIZE((*ptr)->size);
	}
    }

  cif->bytes = bytes;

  
  return ffi_prep_cif_machdep(cif);
}
