

extern "C" {

typedef uint32_t ucs4_t;
typedef unsigned int ucs4_t;

typedef uint16_t ucs2_t, DBCHAR;
typedef unsigned short ucs2_t, DBCHAR;

typedef union {
	void *p;
	int i;
	unsigned char c[8];
	ucs2_t u2[4];
	ucs4_t u4[2];
} MultibyteCodec_State;

typedef int (*mbcodec_init)(const void *config);
typedef Py_ssize_t (*mbencode_func)(MultibyteCodec_State *state,
			const void *config,
			const Py_UNICODE **inbuf, Py_ssize_t inleft,
			unsigned char **outbuf, Py_ssize_t outleft,
			int flags);
typedef int (*mbencodeinit_func)(MultibyteCodec_State *state,
				 const void *config);
typedef Py_ssize_t (*mbencodereset_func)(MultibyteCodec_State *state,
			const void *config,
			unsigned char **outbuf, Py_ssize_t outleft);
typedef Py_ssize_t (*mbdecode_func)(MultibyteCodec_State *state,
			const void *config,
			const unsigned char **inbuf, Py_ssize_t inleft,
			Py_UNICODE **outbuf, Py_ssize_t outleft);
typedef int (*mbdecodeinit_func)(MultibyteCodec_State *state,
				 const void *config);
typedef Py_ssize_t (*mbdecodereset_func)(MultibyteCodec_State *state,
					 const void *config);

typedef struct {
	const char *encoding;
	const void *config;
	mbcodec_init codecinit;
	mbencode_func encode;
	mbencodeinit_func encinit;
	mbencodereset_func encreset;
	mbdecode_func decode;
	mbdecodeinit_func decinit;
	mbdecodereset_func decreset;
} MultibyteCodec;

typedef struct {
	PyObject_HEAD
	MultibyteCodec *codec;
} MultibyteCodecObject;


	PyObject_HEAD				\
	MultibyteCodec *codec;			\
	MultibyteCodec_State state;		\
	PyObject *errors;
typedef struct {
	_MultibyteStatefulCodec_HEAD
} MultibyteStatefulCodecContext;

	_MultibyteStatefulCodec_HEAD		\
	Py_UNICODE pending[MAXENCPENDING];	\
	Py_ssize_t pendingsize;
typedef struct {
	_MultibyteStatefulEncoder_HEAD
} MultibyteStatefulEncoderContext;

	_MultibyteStatefulCodec_HEAD		\
	unsigned char pending[MAXDECPENDING];	\
	Py_ssize_t pendingsize;
typedef struct {
	_MultibyteStatefulDecoder_HEAD
} MultibyteStatefulDecoderContext;

typedef struct {
	_MultibyteStatefulEncoder_HEAD
} MultibyteIncrementalEncoderObject;

typedef struct {
	_MultibyteStatefulDecoder_HEAD
} MultibyteIncrementalDecoderObject;

typedef struct {
	_MultibyteStatefulDecoder_HEAD
	PyObject *stream;
} MultibyteStreamReaderObject;

typedef struct {
	_MultibyteStatefulEncoder_HEAD
	PyObject *stream;
} MultibyteStreamWriterObject;



	if (p != NULL && ERROR_ISCUSTOM(p)) {	\
		Py_DECREF(p);			\
	}					\
} while (0);


}
